#ifndef mozilla_dom_BindingNames_h
#define mozilla_dom_BindingNames_h

#include <stddef.h>
#include <stdint.h>
#include "mozilla/Attributes.h"

namespace mozilla::dom {

enum class BindingNamesOffset : uint16_t {
  ANGLE_instanced_arrays = 0,
  APZHitResultFlags = 23,
  AbortController = 41,
  AbortSignal = 57,
  AbstractRange = 69,
  AccessibleNode = 83,
  Addon = 98,
  AddonEvent = 104,
  AddonInstall = 115,
  AddonManager = 128,
  AddonManagerPermissions = 141,
  AnalyserNode = 165,
  Animation = 178,
  AnimationEffect = 188,
  AnimationEvent = 204,
  AnimationPlaybackEvent = 219,
  AnimationTimeline = 242,
  AnonymousContent = 260,
  Attr = 277,
  Audio = 282,
  AudioBuffer = 288,
  AudioBufferSourceNode = 300,
  AudioContext = 322,
  AudioDestinationNode = 335,
  AudioListener = 356,
  AudioNode = 370,
  AudioParam = 380,
  AudioParamMap = 391,
  AudioProcessingEvent = 405,
  AudioScheduledSourceNode = 426,
  AudioTrack = 451,
  AudioTrackList = 462,
  AudioWorklet = 477,
  AudioWorkletGlobalScope = 490,
  AudioWorkletNode = 514,
  AudioWorkletProcessor = 531,
  AuthenticatorAssertionResponse = 553,
  AuthenticatorAttestationResponse = 584,
  AuthenticatorResponse = 617,
  BarProp = 639,
  BaseAudioContext = 647,
  BatteryManager = 664,
  BeforeUnloadEvent = 679,
  BiquadFilterNode = 697,
  Blob = 714,
  BlobEvent = 719,
  BroadcastChannel = 729,
  BrowsingContext = 746,
  BrowsingContextGroup = 762,
  ByteLengthQueuingStrategy = 783,
  CDATASection = 809,
  CSS = 822,
  CSS2Properties = 826,
  CSSAnimation = 841,
  CSSConditionRule = 854,
  CSSContainerRule = 871,
  CSSCounterStyleRule = 888,
  CSSFontFaceRule = 908,
  CSSFontFeatureValuesRule = 924,
  CSSGroupingRule = 949,
  CSSImportRule = 965,
  CSSKeyframeRule = 979,
  CSSKeyframesRule = 995,
  CSSLayerBlockRule = 1012,
  CSSLayerStatementRule = 1030,
  CSSMediaRule = 1052,
  CSSMozDocumentRule = 1065,
  CSSNamespaceRule = 1084,
  CSSPageRule = 1101,
  CSSPseudoElement = 1113,
  CSSRule = 1130,
  CSSRuleList = 1138,
  CSSScrollTimelineRule = 1150,
  CSSStyleDeclaration = 1172,
  CSSStyleRule = 1192,
  CSSStyleSheet = 1205,
  CSSSupportsRule = 1219,
  CSSTransition = 1235,
  Cache = 1249,
  CacheStorage = 1255,
  CallbackDebuggerNotification = 1268,
  CanonicalBrowsingContext = 1297,
  CanvasCaptureMediaStream = 1322,
  CanvasGradient = 1347,
  CanvasPattern = 1362,
  CanvasRenderingContext2D = 1376,
  CaretPosition = 1401,
  CaretStateChangedEvent = 1415,
  ChannelMergerNode = 1438,
  ChannelSplitterNode = 1456,
  ChannelWrapper = 1476,
  CharacterData = 1491,
  CheckerboardReportService = 1505,
  ChildProcessMessageManager = 1531,
  ChildSHistory = 1558,
  ChromeMessageBroadcaster = 1572,
  ChromeMessageSender = 1597,
  ChromeNodeList = 1617,
  ChromeUtils = 1632,
  ChromeWorker = 1644,
  Client = 1657,
  Clients = 1664,
  Clipboard = 1672,
  ClipboardEvent = 1682,
  ClipboardItem = 1697,
  ClonedErrorHolder = 1711,
  CloseEvent = 1729,
  CommandEvent = 1740,
  Comment = 1753,
  CompositionEvent = 1761,
  ConsoleInstance = 1778,
  ConstantSourceNode = 1794,
  ContentFrameMessageManager = 1813,
  ContentProcessMessageManager = 1840,
  ConvolverNode = 1869,
  CountQueuingStrategy = 1883,
  CreateOfferRequest = 1904,
  Credential = 1923,
  CredentialsContainer = 1934,
  Crypto = 1955,
  CryptoKey = 1962,
  CustomElementRegistry = 1972,
  CustomEvent = 1994,
  DOMException = 2006,
  DOMImplementation = 2019,
  DOMLocalization = 2037,
  DOMMatrix = 2053,
  DOMMatrixReadOnly = 2063,
  DOMParser = 2081,
  DOMPoint = 2091,
  DOMPointReadOnly = 2100,
  DOMQuad = 2117,
  DOMRect = 2125,
  DOMRectList = 2133,
  DOMRectReadOnly = 2145,
  DOMRequest = 2161,
  DOMStringList = 2172,
  DOMStringMap = 2186,
  DOMTokenList = 2199,
  DataTransfer = 2212,
  DataTransferItem = 2225,
  DataTransferItemList = 2242,
  DebuggerNotification = 2263,
  DebuggerNotificationObserver = 2284,
  DedicatedWorkerGlobalScope = 2313,
  DelayNode = 2340,
  DeprecationReportBody = 2350,
  DeviceAcceleration = 2372,
  DeviceLightEvent = 2391,
  DeviceMotionEvent = 2408,
  DeviceOrientationEvent = 2426,
  DeviceRotationRate = 2449,
  Directory = 2468,
  Document = 2478,
  DocumentFragment = 2487,
  DocumentL10n = 2504,
  DocumentTimeline = 2517,
  DocumentType = 2534,
  DominatorTree = 2547,
  DragEvent = 2561,
  DynamicsCompressorNode = 2571,
  EXT_blend_minmax = 2594,
  EXT_color_buffer_float = 2611,
  EXT_color_buffer_half_float = 2634,
  EXT_disjoint_timer_query = 2662,
  EXT_float_blend = 2687,
  EXT_frag_depth = 2703,
  EXT_sRGB = 2718,
  EXT_shader_texture_lod = 2727,
  EXT_texture_compression_bptc = 2750,
  EXT_texture_compression_rgtc = 2779,
  EXT_texture_filter_anisotropic = 2808,
  EXT_texture_norm16 = 2839,
  Element = 2858,
  ElementInternals = 2866,
  ErrorEvent = 2883,
  Event = 2894,
  EventCallbackDebuggerNotification = 2900,
  EventCounts = 2934,
  EventSource = 2946,
  EventTarget = 2958,
  Exception = 2970,
  ExtendableEvent = 2980,
  ExtendableMessageEvent = 2996,
  ExtensionAlarms = 3019,
  ExtensionBrowser = 3035,
  ExtensionEventManager = 3052,
  ExtensionMockAPI = 3074,
  ExtensionPort = 3091,
  ExtensionRuntime = 3105,
  ExtensionTest = 3122,
  External = 3136,
  FeaturePolicy = 3145,
  FeaturePolicyViolationReportBody = 3159,
  FetchEvent = 3192,
  FetchObserver = 3203,
  File = 3217,
  FileList = 3222,
  FileReader = 3231,
  FileReaderSync = 3242,
  FileSystem = 3257,
  FileSystemDirectoryEntry = 3268,
  FileSystemDirectoryHandle = 3293,
  FileSystemDirectoryIterator = 3319,
  FileSystemDirectoryReader = 3347,
  FileSystemEntry = 3373,
  FileSystemFileEntry = 3389,
  FileSystemFileHandle = 3409,
  FileSystemHandle = 3430,
  FileSystemSyncAccessHandle = 3447,
  FileSystemWritableFileStream = 3474,
  Flex = 3503,
  FlexItemValues = 3508,
  FlexLineValues = 3523,
  FluentBundle = 3538,
  FluentBundleAsyncIterator = 3551,
  FluentBundleIterator = 3577,
  FluentPattern = 3598,
  FluentResource = 3612,
  FocusEvent = 3627,
  FontFace = 3638,
  FontFaceSet = 3647,
  FontFaceSetIterator = 3659,
  FontFaceSetLoadEvent = 3679,
  FormData = 3700,
  FormData_Iterator = 3709,
  FormDataEvent = 3727,
  FrameCrashedEvent = 3741,
  FrameLoader = 3759,
  GPU = 3771,
  GPUAdapter = 3775,
  GPUBindGroup = 3786,
  GPUBindGroupLayout = 3799,
  GPUBuffer = 3818,
  GPUBufferUsage = 3828,
  GPUCanvasContext = 3843,
  GPUColorWrite = 3860,
  GPUCommandBuffer = 3874,
  GPUCommandEncoder = 3891,
  GPUCompilationInfo = 3909,
  GPUCompilationMessage = 3928,
  GPUComputePassEncoder = 3950,
  GPUComputePipeline = 3972,
  GPUDevice = 3991,
  GPUDeviceLostInfo = 4001,
  GPUMapMode = 4019,
  GPUOutOfMemoryError = 4030,
  GPUPipelineLayout = 4050,
  GPUQuerySet = 4068,
  GPUQueue = 4080,
  GPURenderBundle = 4089,
  GPURenderBundleEncoder = 4105,
  GPURenderPassEncoder = 4128,
  GPURenderPipeline = 4149,
  GPUSampler = 4167,
  GPUShaderModule = 4178,
  GPUShaderStage = 4194,
  GPUSupportedFeatures = 4209,
  GPUSupportedLimits = 4230,
  GPUTexture = 4249,
  GPUTextureUsage = 4260,
  GPUTextureView = 4276,
  GPUUncapturedErrorEvent = 4291,
  GPUValidationError = 4315,
  GainNode = 4334,
  Gamepad = 4343,
  GamepadAxisMoveEvent = 4351,
  GamepadButton = 4372,
  GamepadButtonEvent = 4386,
  GamepadEvent = 4405,
  GamepadHapticActuator = 4418,
  GamepadLightIndicator = 4440,
  GamepadPose = 4462,
  GamepadServiceTest = 4474,
  GamepadTouch = 4493,
  Geolocation = 4506,
  GeolocationCoordinates = 4518,
  GeolocationPosition = 4541,
  GeolocationPositionError = 4561,
  GetUserMediaRequest = 4586,
  GleanCategory = 4606,
  GleanImpl = 4620,
  GleanLabeled = 4630,
  GleanPingsImpl = 4643,
  Grid = 4658,
  GridArea = 4663,
  GridDimension = 4672,
  GridLine = 4686,
  GridLines = 4695,
  GridTrack = 4705,
  GridTracks = 4715,
  HTMLAllCollection = 4726,
  HTMLAnchorElement = 4744,
  HTMLAreaElement = 4762,
  HTMLAudioElement = 4778,
  HTMLBRElement = 4795,
  HTMLBaseElement = 4809,
  HTMLBodyElement = 4825,
  HTMLButtonElement = 4841,
  HTMLCanvasElement = 4859,
  HTMLCollection = 4877,
  HTMLDListElement = 4892,
  HTMLDataElement = 4909,
  HTMLDataListElement = 4925,
  HTMLDetailsElement = 4945,
  HTMLDialogElement = 4964,
  HTMLDirectoryElement = 4982,
  HTMLDivElement = 5003,
  HTMLDocument = 5018,
  HTMLElement = 5031,
  HTMLEmbedElement = 5043,
  HTMLFieldSetElement = 5060,
  HTMLFontElement = 5080,
  HTMLFormControlsCollection = 5096,
  HTMLFormElement = 5123,
  HTMLFrameElement = 5139,
  HTMLFrameSetElement = 5156,
  HTMLHRElement = 5176,
  HTMLHeadElement = 5190,
  HTMLHeadingElement = 5206,
  HTMLHtmlElement = 5225,
  HTMLIFrameElement = 5241,
  HTMLImageElement = 5259,
  HTMLInputElement = 5276,
  HTMLLIElement = 5293,
  HTMLLabelElement = 5307,
  HTMLLegendElement = 5324,
  HTMLLinkElement = 5342,
  HTMLMapElement = 5358,
  HTMLMarqueeElement = 5373,
  HTMLMediaElement = 5392,
  HTMLMenuElement = 5409,
  HTMLMetaElement = 5425,
  HTMLMeterElement = 5441,
  HTMLModElement = 5458,
  HTMLOListElement = 5473,
  HTMLObjectElement = 5490,
  HTMLOptGroupElement = 5508,
  HTMLOptionElement = 5528,
  HTMLOptionsCollection = 5546,
  HTMLOutputElement = 5568,
  HTMLParagraphElement = 5586,
  HTMLParamElement = 5607,
  HTMLPictureElement = 5624,
  HTMLPreElement = 5643,
  HTMLProgressElement = 5658,
  HTMLQuoteElement = 5678,
  HTMLScriptElement = 5695,
  HTMLSelectElement = 5713,
  HTMLSlotElement = 5731,
  HTMLSourceElement = 5747,
  HTMLSpanElement = 5765,
  HTMLStyleElement = 5781,
  HTMLTableCaptionElement = 5798,
  HTMLTableCellElement = 5822,
  HTMLTableColElement = 5843,
  HTMLTableElement = 5863,
  HTMLTableRowElement = 5880,
  HTMLTableSectionElement = 5900,
  HTMLTemplateElement = 5924,
  HTMLTextAreaElement = 5944,
  HTMLTimeElement = 5964,
  HTMLTitleElement = 5980,
  HTMLTrackElement = 5997,
  HTMLUListElement = 6014,
  HTMLUnknownElement = 6031,
  HTMLVideoElement = 6050,
  HashChangeEvent = 6067,
  Headers = 6083,
  Headers_Iterator = 6091,
  HeapSnapshot = 6108,
  History = 6121,
  IDBCursor = 6129,
  IDBCursorWithValue = 6139,
  IDBDatabase = 6158,
  IDBFactory = 6170,
  IDBFileHandle = 6181,
  IDBFileRequest = 6195,
  IDBIndex = 6210,
  IDBKeyRange = 6219,
  IDBLocaleAwareKeyRange = 6231,
  IDBMutableFile = 6254,
  IDBObjectStore = 6269,
  IDBOpenDBRequest = 6284,
  IDBRequest = 6301,
  IDBTransaction = 6312,
  IDBVersionChangeEvent = 6327,
  IIRFilterNode = 6349,
  IOUtils = 6363,
  IdleDeadline = 6371,
  Image = 6384,
  ImageBitmap = 6390,
  ImageBitmapRenderingContext = 6402,
  ImageCapture = 6430,
  ImageCaptureError = 6443,
  ImageCaptureErrorEvent = 6461,
  ImageData = 6484,
  ImageDocument = 6494,
  InputEvent = 6508,
  InspectorFontFace = 6519,
  InspectorUtils = 6537,
  InstallTriggerImpl = 6552,
  IntersectionObserver = 6571,
  IntersectionObserverEntry = 6592,
  IntlUtils = 6618,
  JSProcessActorChild = 6628,
  JSProcessActorParent = 6648,
  JSWindowActorChild = 6669,
  JSWindowActorParent = 6688,
  KeyEvent = 6708,
  KeyboardEvent = 6717,
  KeyframeEffect = 6731,
  L10nFileSource = 6746,
  L10nOverlays = 6761,
  L10nRegistry = 6774,
  LegacyMozTCPSocket = 6787,
  Localization = 6806,
  Location = 6819,
  Lock = 6828,
  LockManager = 6833,
  MIDIAccess = 6845,
  MIDIConnectionEvent = 6856,
  MIDIInput = 6876,
  MIDIInputMap = 6886,
  MIDIMessageEvent = 6899,
  MIDIOutput = 6916,
  MIDIOutputMap = 6927,
  MIDIPort = 6941,
  MOZ_debug = 6950,
  MatchGlob = 6960,
  MatchPattern = 6970,
  MatchPatternSet = 6983,
  MathMLElement = 6999,
  MediaCapabilities = 7013,
  MediaCapabilitiesInfo = 7031,
  MediaControlService = 7053,
  MediaController = 7073,
  MediaDeviceInfo = 7089,
  MediaDevices = 7105,
  MediaElementAudioSourceNode = 7118,
  MediaEncryptedEvent = 7146,
  MediaError = 7166,
  MediaKeyError = 7177,
  MediaKeyMessageEvent = 7191,
  MediaKeySession = 7212,
  MediaKeyStatusMap = 7228,
  MediaKeyStatusMap_Iterator = 7246,
  MediaKeySystemAccess = 7273,
  MediaKeys = 7294,
  MediaList = 7304,
  MediaMetadata = 7314,
  MediaQueryList = 7328,
  MediaQueryListEvent = 7343,
  MediaRecorder = 7363,
  MediaRecorderErrorEvent = 7377,
  MediaSession = 7401,
  MediaSource = 7414,
  MediaStream = 7426,
  MediaStreamAudioDestinationNode = 7438,
  MediaStreamAudioSourceNode = 7470,
  MediaStreamError = 7497,
  MediaStreamEvent = 7514,
  MediaStreamTrack = 7531,
  MediaStreamTrackAudioSourceNode = 7548,
  MediaStreamTrackEvent = 7580,
  MerchantValidationEvent = 7602,
  MessageBroadcaster = 7626,
  MessageChannel = 7645,
  MessageEvent = 7660,
  MessageListenerManager = 7673,
  MessagePort = 7696,
  MessageSender = 7708,
  MimeType = 7722,
  MimeTypeArray = 7731,
  MouseEvent = 7745,
  MouseScrollEvent = 7756,
  MozCanvasPrintState = 7773,
  MozDocumentMatcher = 7793,
  MozDocumentObserver = 7812,
  MozQueryInterface = 7832,
  MozSharedMap = 7850,
  MozSharedMap_Iterator = 7863,
  MozSharedMapChangeEvent = 7885,
  MozStorageAsyncStatementParams = 7909,
  MozStorageStatementParams = 7940,
  MozStorageStatementRow = 7966,
  MozWritableSharedMap = 7989,
  MutationEvent = 8010,
  MutationObserver = 8024,
  MutationRecord = 8041,
  NamedNodeMap = 8056,
  NavigationPreloadManager = 8069,
  Navigator = 8094,
  NetworkInformation = 8104,
  Node = 8123,
  NodeFilter = 8128,
  NodeIterator = 8139,
  NodeList = 8152,
  Notification = 8161,
  NotificationEvent = 8174,
  NotifyPaintEvent = 8192,
  OES_draw_buffers_indexed = 8209,
  OES_element_index_uint = 8234,
  OES_fbo_render_mipmap = 8257,
  OES_standard_derivatives = 8279,
  OES_texture_float = 8304,
  OES_texture_float_linear = 8322,
  OES_texture_half_float = 8347,
  OES_texture_half_float_linear = 8370,
  OES_vertex_array_object = 8400,
  OVR_multiview2 = 8424,
  OfflineAudioCompletionEvent = 8439,
  OfflineAudioContext = 8467,
  OfflineResourceList = 8487,
  OffscreenCanvas = 8507,
  OffscreenCanvasRenderingContext2D = 8523,
  OnlyForUseInConstructor = 8557,
  Option = 8581,
  OscillatorNode = 8588,
  PageTransitionEvent = 8603,
  PaintRequest = 8623,
  PaintRequestList = 8636,
  PaintWorkletGlobalScope = 8653,
  PannerNode = 8677,
  ParentProcessMessageManager = 8688,
  Path2D = 8716,
  PathUtils = 8723,
  PaymentAddress = 8733,
  PaymentMethodChangeEvent = 8748,
  PaymentRequest = 8773,
  PaymentRequestUpdateEvent = 8788,
  PaymentResponse = 8814,
  PeerConnectionImpl = 8830,
  PeerConnectionObserver = 8849,
  Performance = 8872,
  PerformanceEntry = 8884,
  PerformanceEntryEvent = 8901,
  PerformanceEventTiming = 8923,
  PerformanceMark = 8946,
  PerformanceMeasure = 8962,
  PerformanceNavigation = 8981,
  PerformanceNavigationTiming = 9003,
  PerformanceObserver = 9031,
  PerformanceObserverEntryList = 9051,
  PerformancePaintTiming = 9080,
  PerformanceResourceTiming = 9103,
  PerformanceServerTiming = 9129,
  PerformanceTiming = 9153,
  PeriodicWave = 9171,
  PermissionStatus = 9184,
  Permissions = 9201,
  PlacesBookmark = 9213,
  PlacesBookmarkAddition = 9228,
  PlacesBookmarkChanged = 9251,
  PlacesBookmarkGuid = 9273,
  PlacesBookmarkMoved = 9292,
  PlacesBookmarkRemoved = 9312,
  PlacesBookmarkTags = 9334,
  PlacesBookmarkTime = 9353,
  PlacesBookmarkTitle = 9372,
  PlacesBookmarkUrl = 9392,
  PlacesEvent = 9410,
  PlacesFavicon = 9422,
  PlacesHistoryCleared = 9436,
  PlacesObservers = 9457,
  PlacesPurgeCaches = 9473,
  PlacesRanking = 9491,
  PlacesVisit = 9505,
  PlacesVisitRemoved = 9517,
  PlacesVisitTitle = 9536,
  PlacesWeakCallbackWrapper = 9553,
  Plugin = 9579,
  PluginArray = 9586,
  PluginCrashedEvent = 9598,
  PointerEvent = 9617,
  PopStateEvent = 9630,
  PopupBlockedEvent = 9644,
  PopupPositionedEvent = 9662,
  PositionStateEvent = 9683,
  PrecompiledScript = 9702,
  PrioEncoder = 9720,
  ProcessMessageManager = 9732,
  ProcessingInstruction = 9754,
  ProgressEvent = 9776,
  PromiseDebugging = 9790,
  PromiseNativeHandler = 9807,
  PromiseRejectionEvent = 9828,
  PublicKeyCredential = 9850,
  PushEvent = 9870,
  PushManager = 9880,
  PushManagerImpl = 9892,
  PushMessageData = 9908,
  PushSubscription = 9924,
  PushSubscriptionOptions = 9941,
  RTCCertificate = 9965,
  RTCDTMFSender = 9980,
  RTCDTMFToneChangeEvent = 9994,
  RTCDataChannel = 10017,
  RTCDataChannelEvent = 10032,
  RTCDtlsTransport = 10052,
  RTCIceCandidate = 10069,
  RTCIdentityProviderRegistrar = 10085,
  RTCPeerConnection = 10114,
  RTCPeerConnectionIceEvent = 10132,
  RTCPeerConnectionStatic = 10158,
  RTCRtpReceiver = 10182,
  RTCRtpSender = 10197,
  RTCRtpTransceiver = 10210,
  RTCSessionDescription = 10228,
  RTCStatsReport = 10250,
  RTCTrackEvent = 10265,
  RadioNodeList = 10279,
  Range = 10293,
  ReadableByteStreamController = 10299,
  ReadableStream = 10328,
  ReadableStreamBYOBReader = 10343,
  ReadableStreamBYOBRequest = 10368,
  ReadableStreamDefaultController = 10394,
  ReadableStreamDefaultReader = 10426,
  Report = 10454,
  ReportBody = 10461,
  ReportingObserver = 10472,
  Request = 10490,
  ResizeObserver = 10498,
  ResizeObserverEntry = 10513,
  ResizeObserverSize = 10533,
  Response = 10552,
  SVGAElement = 10561,
  SVGAngle = 10573,
  SVGAnimateElement = 10582,
  SVGAnimateMotionElement = 10600,
  SVGAnimateTransformElement = 10624,
  SVGAnimatedAngle = 10651,
  SVGAnimatedBoolean = 10668,
  SVGAnimatedEnumeration = 10687,
  SVGAnimatedInteger = 10710,
  SVGAnimatedLength = 10729,
  SVGAnimatedLengthList = 10747,
  SVGAnimatedNumber = 10769,
  SVGAnimatedNumberList = 10787,
  SVGAnimatedPreserveAspectRatio = 10809,
  SVGAnimatedRect = 10840,
  SVGAnimatedString = 10856,
  SVGAnimatedTransformList = 10874,
  SVGAnimationElement = 10899,
  SVGCircleElement = 10919,
  SVGClipPathElement = 10936,
  SVGComponentTransferFunctionElement = 10955,
  SVGDefsElement = 10991,
  SVGDescElement = 11006,
  SVGElement = 11021,
  SVGEllipseElement = 11032,
  SVGFEBlendElement = 11050,
  SVGFEColorMatrixElement = 11068,
  SVGFEComponentTransferElement = 11092,
  SVGFECompositeElement = 11122,
  SVGFEConvolveMatrixElement = 11144,
  SVGFEDiffuseLightingElement = 11171,
  SVGFEDisplacementMapElement = 11199,
  SVGFEDistantLightElement = 11227,
  SVGFEDropShadowElement = 11252,
  SVGFEFloodElement = 11275,
  SVGFEFuncAElement = 11293,
  SVGFEFuncBElement = 11311,
  SVGFEFuncGElement = 11329,
  SVGFEFuncRElement = 11347,
  SVGFEGaussianBlurElement = 11365,
  SVGFEImageElement = 11390,
  SVGFEMergeElement = 11408,
  SVGFEMergeNodeElement = 11426,
  SVGFEMorphologyElement = 11448,
  SVGFEOffsetElement = 11471,
  SVGFEPointLightElement = 11490,
  SVGFESpecularLightingElement = 11513,
  SVGFESpotLightElement = 11542,
  SVGFETileElement = 11564,
  SVGFETurbulenceElement = 11581,
  SVGFilterElement = 11604,
  SVGForeignObjectElement = 11621,
  SVGGElement = 11645,
  SVGGeometryElement = 11657,
  SVGGradientElement = 11676,
  SVGGraphicsElement = 11695,
  SVGImageElement = 11714,
  SVGLength = 11730,
  SVGLengthList = 11740,
  SVGLineElement = 11754,
  SVGLinearGradientElement = 11769,
  SVGMPathElement = 11794,
  SVGMarkerElement = 11810,
  SVGMaskElement = 11827,
  SVGMatrix = 11842,
  SVGMetadataElement = 11852,
  SVGNumber = 11871,
  SVGNumberList = 11881,
  SVGPathElement = 11895,
  SVGPathSeg = 11910,
  SVGPathSegArcAbs = 11921,
  SVGPathSegArcRel = 11938,
  SVGPathSegClosePath = 11955,
  SVGPathSegCurvetoCubicAbs = 11975,
  SVGPathSegCurvetoCubicRel = 12001,
  SVGPathSegCurvetoCubicSmoothAbs = 12027,
  SVGPathSegCurvetoCubicSmoothRel = 12059,
  SVGPathSegCurvetoQuadraticAbs = 12091,
  SVGPathSegCurvetoQuadraticRel = 12121,
  SVGPathSegCurvetoQuadraticSmoothAbs = 12151,
  SVGPathSegCurvetoQuadraticSmoothRel = 12187,
  SVGPathSegLinetoAbs = 12223,
  SVGPathSegLinetoHorizontalAbs = 12243,
  SVGPathSegLinetoHorizontalRel = 12273,
  SVGPathSegLinetoRel = 12303,
  SVGPathSegLinetoVerticalAbs = 12323,
  SVGPathSegLinetoVerticalRel = 12351,
  SVGPathSegList = 12379,
  SVGPathSegMovetoAbs = 12394,
  SVGPathSegMovetoRel = 12414,
  SVGPatternElement = 12434,
  SVGPoint = 12452,
  SVGPointList = 12461,
  SVGPolygonElement = 12474,
  SVGPolylineElement = 12492,
  SVGPreserveAspectRatio = 12511,
  SVGRadialGradientElement = 12534,
  SVGRect = 12559,
  SVGRectElement = 12567,
  SVGSVGElement = 12582,
  SVGScriptElement = 12596,
  SVGSetElement = 12613,
  SVGStopElement = 12627,
  SVGStringList = 12642,
  SVGStyleElement = 12656,
  SVGSwitchElement = 12672,
  SVGSymbolElement = 12689,
  SVGTSpanElement = 12706,
  SVGTextContentElement = 12722,
  SVGTextElement = 12744,
  SVGTextPathElement = 12759,
  SVGTextPositioningElement = 12778,
  SVGTitleElement = 12804,
  SVGTransform = 12820,
  SVGTransformList = 12833,
  SVGUnitTypes = 12850,
  SVGUseElement = 12863,
  SVGViewElement = 12877,
  Sanitizer = 12892,
  Scheduler = 12902,
  Screen = 12912,
  ScreenLuminance = 12919,
  ScreenOrientation = 12935,
  ScriptProcessorNode = 12953,
  ScrollAreaEvent = 12973,
  ScrollViewChangeEvent = 12989,
  SecurityPolicyViolationEvent = 13011,
  Selection = 13040,
  ServiceWorker = 13050,
  ServiceWorkerContainer = 13064,
  ServiceWorkerGlobalScope = 13087,
  ServiceWorkerRegistration = 13112,
  SessionStoreFormData = 13138,
  SessionStoreScrollData = 13159,
  SessionStoreUtils = 13182,
  ShadowRealmGlobalScope = 13200,
  ShadowRoot = 13223,
  SharedWorker = 13234,
  SharedWorkerGlobalScope = 13247,
  SimpleGestureEvent = 13271,
  SourceBuffer = 13290,
  SourceBufferList = 13303,
  SpeechGrammar = 13320,
  SpeechGrammarList = 13334,
  SpeechRecognition = 13352,
  SpeechRecognitionAlternative = 13370,
  SpeechRecognitionError = 13399,
  SpeechRecognitionEvent = 13422,
  SpeechRecognitionResult = 13445,
  SpeechRecognitionResultList = 13469,
  SpeechSynthesis = 13497,
  SpeechSynthesisErrorEvent = 13513,
  SpeechSynthesisEvent = 13539,
  SpeechSynthesisUtterance = 13560,
  SpeechSynthesisVoice = 13585,
  StaticRange = 13606,
  StereoPannerNode = 13618,
  Storage = 13635,
  StorageEvent = 13643,
  StorageManager = 13656,
  StreamFilter = 13671,
  StreamFilterDataEvent = 13684,
  StructuredCloneHolder = 13706,
  StructuredCloneTester = 13728,
  StyleSheet = 13750,
  StyleSheetApplicableStateChangeEvent = 13761,
  StyleSheetList = 13798,
  SubmitEvent = 13813,
  SubtleCrypto = 13825,
  SyncMessageSender = 13838,
  SyncReadFile = 13856,
  TCPServerSocket = 13869,
  TCPServerSocketEvent = 13885,
  TCPSocket = 13906,
  TCPSocketErrorEvent = 13916,
  TCPSocketEvent = 13936,
  TaskController = 13951,
  TaskPriorityChangeEvent = 13966,
  TaskSignal = 13990,
  TelemetryStopwatch = 14001,
  TestAttributesOnTypes = 14020,
  TestCEReactionsInterface = 14042,
  TestCImplementedInterface = 14067,
  TestCImplementedInterface2 = 14093,
  TestChildInterface = 14120,
  TestConstructorForFuncInterface = 14139,
  TestConstructorForPrefInterface = 14171,
  TestConstructorForSCInterface = 14203,
  TestCppKeywordNamedMethodsInterface = 14233,
  TestDeprecatedInterface = 14269,
  TestExampleInterface = 14293,
  TestExampleProxyInterface = 14314,
  TestExampleThrowingConstructorInterface = 14340,
  TestExampleWorkerInterface = 14380,
  TestFuncConstructorForDifferentFuncInterface = 14407,
  TestFuncConstructorForInterface = 14452,
  TestHTMLConstructorInterface = 14484,
  TestIndexedAndNamedGetterAndSetterInterface = 14513,
  TestIndexedAndNamedGetterInterface = 14557,
  TestIndexedAndNamedSetterInterface = 14592,
  TestIndexedGetterAndSetterAndNamedGetterInterface = 14627,
  TestIndexedGetterInterface = 14677,
  TestIndexedSetterInterface = 14704,
  TestInterface = 14731,
  TestInterfaceWithPromiseConstructorArg = 14745,
  TestJSImplInterface = 14784,
  TestJSImplInterface2 = 14804,
  TestJSImplInterface3 = 14825,
  TestJSImplInterface4 = 14846,
  TestJSImplInterface5 = 14867,
  TestJSImplInterface6 = 14888,
  TestJSImplNoInterfaceObject = 14909,
  TestNamedDeleterInterface = 14937,
  TestNamedDeleterWithRetvalInterface = 14963,
  TestNamedGetterInterface = 14999,
  TestNamedSetterInterface = 15024,
  TestNamespace = 15049,
  TestNonWrapperCacheInterface = 15063,
  TestParentInterface = 15092,
  TestPrefChromeOnlySCFuncConstructorForInterface = 15112,
  TestPrefConstructorForDifferentPrefInterface = 15160,
  TestPrefConstructorForInterface = 15205,
  TestProtoObjectHackedNamespace = 15237,
  TestRenamedInterface = 15268,
  TestRenamedNamespace = 15289,
  TestSCConstructorForInterface = 15310,
  TestSecureContextInterface = 15340,
  TestThrowingConstructorInterface = 15367,
  TestUtils = 15400,
  TestWorkerExposedInterface = 15410,
  TestingDeprecatedInterface = 15437,
  Text = 15464,
  TextClause = 15469,
  TextDecoder = 15480,
  TextEncoder = 15492,
  TextMetrics = 15504,
  TextTrack = 15516,
  TextTrackCue = 15526,
  TextTrackCueList = 15539,
  TextTrackList = 15556,
  TimeEvent = 15570,
  TimeRanges = 15580,
  Touch = 15591,
  TouchEvent = 15597,
  TouchList = 15608,
  TrackEvent = 15618,
  TransformStream = 15629,
  TransformStreamDefaultController = 15645,
  TransitionEvent = 15678,
  TreeColumn = 15694,
  TreeColumns = 15705,
  TreeContentView = 15717,
  TreeWalker = 15733,
  U2F = 15744,
  UDPMessageEvent = 15748,
  UDPSocket = 15764,
  UIEvent = 15774,
  URL = 15782,
  URLSearchParams = 15786,
  URLSearchParams_Iterator = 15802,
  UserInteraction = 15827,
  UserProximityEvent = 15843,
  VRDisplay = 15862,
  VRDisplayCapabilities = 15872,
  VRDisplayEvent = 15894,
  VREyeParameters = 15909,
  VRFieldOfView = 15925,
  VRFrameData = 15939,
  VRMockController = 15951,
  VRMockDisplay = 15968,
  VRPose = 15982,
  VRServiceTest = 15989,
  VRStageParameters = 16003,
  VTTCue = 16021,
  VTTRegion = 16028,
  ValidityState = 16038,
  VideoPlaybackQuality = 16052,
  VideoTrack = 16073,
  VideoTrackList = 16084,
  VisualViewport = 16099,
  WEBGL_color_buffer_float = 16114,
  WEBGL_compressed_texture_astc = 16139,
  WEBGL_compressed_texture_etc = 16169,
  WEBGL_compressed_texture_etc1 = 16198,
  WEBGL_compressed_texture_pvrtc = 16228,
  WEBGL_compressed_texture_s3tc = 16259,
  WEBGL_compressed_texture_s3tc_srgb = 16289,
  WEBGL_debug_renderer_info = 16324,
  WEBGL_debug_shaders = 16350,
  WEBGL_depth_texture = 16370,
  WEBGL_draw_buffers = 16390,
  WEBGL_explicit_present = 16409,
  WEBGL_lose_context = 16432,
  WaveShaperNode = 16451,
  WebExtensionContentScript = 16466,
  WebExtensionPolicy = 16492,
  WebGL2RenderingContext = 16511,
  WebGLActiveInfo = 16534,
  WebGLBuffer = 16550,
  WebGLContextEvent = 16562,
  WebGLFramebuffer = 16580,
  WebGLProgram = 16597,
  WebGLQuery = 16610,
  WebGLRenderbuffer = 16621,
  WebGLRenderingContext = 16639,
  WebGLSampler = 16661,
  WebGLShader = 16674,
  WebGLShaderPrecisionFormat = 16686,
  WebGLSync = 16713,
  WebGLTexture = 16723,
  WebGLTransformFeedback = 16736,
  WebGLUniformLocation = 16759,
  WebGLVertexArrayObject = 16780,
  WebKitCSSMatrix = 16803,
  WebSocket = 16819,
  WebrtcGlobalInformation = 16829,
  WheelEvent = 16853,
  Window = 16864,
  WindowClient = 16871,
  WindowContext = 16884,
  WindowGlobalChild = 16898,
  WindowGlobalParent = 16916,
  WindowRoot = 16935,
  Worker = 16946,
  WorkerDebuggerGlobalScope = 16953,
  WorkerGlobalScope = 16979,
  WorkerLocation = 16997,
  WorkerNavigator = 17012,
  WorkerTestUtils = 17028,
  Worklet = 17044,
  WorkletGlobalScope = 17052,
  WritableStream = 17071,
  WritableStreamDefaultController = 17086,
  WritableStreamDefaultWriter = 17118,
  XMLDocument = 17146,
  XMLHttpRequest = 17158,
  XMLHttpRequestEventTarget = 17173,
  XMLHttpRequestUpload = 17199,
  XMLSerializer = 17220,
  XPathEvaluator = 17234,
  XPathExpression = 17249,
  XPathResult = 17265,
  XRBoundedReferenceSpace = 17277,
  XRFrame = 17301,
  XRInputSource = 17309,
  XRInputSourceArray = 17323,
  XRInputSourceEvent = 17342,
  XRInputSourcesChangeEvent = 17361,
  XRPose = 17387,
  XRReferenceSpace = 17394,
  XRReferenceSpaceEvent = 17411,
  XRRenderState = 17433,
  XRRigidTransform = 17447,
  XRSession = 17464,
  XRSessionEvent = 17474,
  XRSpace = 17489,
  XRSystem = 17497,
  XRView = 17506,
  XRViewerPose = 17513,
  XRViewport = 17526,
  XRWebGLLayer = 17537,
  XSLTProcessor = 17550,
  XULCommandEvent = 17564,
  XULElement = 17580,
  XULFrameElement = 17591,
  XULMenuElement = 17607,
  XULPopupElement = 17622,
  XULResizerElement = 17638,
  XULTextElement = 17656,
  XULTreeElement = 17671,
  console = 17686,
  mozRTCIceCandidate = 17694,
  mozRTCPeerConnection = 17713,
  mozRTCSessionDescription = 17734,
  webkitSpeechGrammar = 17759,
  webkitSpeechGrammarList = 17779,
  webkitSpeechRecognition = 17803,
  webkitURL = 17827,
};

namespace binding_detail {
extern const char sBindingNames[];
}  // namespace binding_detail

MOZ_ALWAYS_INLINE const char* BindingName(BindingNamesOffset aOffset) {
  return binding_detail::sBindingNames + static_cast<size_t>(aOffset);
}

} // namespace mozilla::dom


#endif // mozilla_dom_BindingNames_h
