/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */
#ifndef mozilla_glean_jog_ffi_generated_h
#define mozilla_glean_jog_ffi_generated_h


/* Generated with cbindgen:0.24.3 */

/* DO NOT MODIFY THIS MANUALLY! This file was generated using cbindgen. */

#include <cstdarg>
#include <cstdint>
#include <cstdlib>
#include <ostream>
#include <new>
#include "nsTArray.h"
#include "nsString.h"

namespace mozilla::glean::jog {

extern "C" {

/// Activate the JOG runtime registrar.
/// This is where the Artefact Build support happens.
///
/// returns whether it successfully found and processed metrics files.
bool jog_runtime_registrar();

/// Test-only method.
///
/// Registers a metric.
/// Doesn't check to see if it's been registered before.
/// Doesn't check that it would pass schema validation if it were a real metric.
///
/// `extra_args` is a JSON-encoded string in a form that serde can read into an ExtraMetricArgs.
///
/// No effort has been made to make this pleasant to use, since it's for
/// internal testing only (ie, the testing of JOG itself).
uint32_t jog_test_register_metric(const nsACString *metric_type,
                                  const nsACString *category,
                                  const nsACString *name,
                                  const nsTArray<nsCString> *send_in_pings,
                                  const nsACString *lifetime,
                                  bool disabled,
                                  const nsACString *extra_args);

/// Test-only method.
///
/// Registers a ping. Doesn't check to see if it's been registered before.
/// Doesn't check that it would pass schema validation if it were a real ping.
void jog_test_register_ping();

/// Test-only method.
///
/// Clears all runtime registration storage of registered metrics and pings.
void jog_test_clear_registered_metrics_and_pings();

} // extern "C"

} // namespace mozilla::glean::jog

#endif // mozilla_glean_jog_ffi_generated_h
