#include "mozilla/EnumTypeTraits.h"
#include "mozilla/dom/BindingNames.h"

namespace mozilla::dom {

namespace binding_detail {

const char sBindingNames[] = {
  /*     0 */ "ANGLE_instanced_arrays" "\0"
  /*    23 */ "APZHitResultFlags" "\0"
  /*    41 */ "AbortController" "\0"
  /*    57 */ "AbortSignal" "\0"
  /*    69 */ "AbstractRange" "\0"
  /*    83 */ "AccessibleNode" "\0"
  /*    98 */ "Addon" "\0"
  /*   104 */ "AddonEvent" "\0"
  /*   115 */ "AddonInstall" "\0"
  /*   128 */ "AddonManager" "\0"
  /*   141 */ "AddonManagerPermissions" "\0"
  /*   165 */ "AnalyserNode" "\0"
  /*   178 */ "Animation" "\0"
  /*   188 */ "AnimationEffect" "\0"
  /*   204 */ "AnimationEvent" "\0"
  /*   219 */ "AnimationPlaybackEvent" "\0"
  /*   242 */ "AnimationTimeline" "\0"
  /*   260 */ "AnonymousContent" "\0"
  /*   277 */ "Attr" "\0"
  /*   282 */ "Audio" "\0"
  /*   288 */ "AudioBuffer" "\0"
  /*   300 */ "AudioBufferSourceNode" "\0"
  /*   322 */ "AudioContext" "\0"
  /*   335 */ "AudioDestinationNode" "\0"
  /*   356 */ "AudioListener" "\0"
  /*   370 */ "AudioNode" "\0"
  /*   380 */ "AudioParam" "\0"
  /*   391 */ "AudioParamMap" "\0"
  /*   405 */ "AudioProcessingEvent" "\0"
  /*   426 */ "AudioScheduledSourceNode" "\0"
  /*   451 */ "AudioTrack" "\0"
  /*   462 */ "AudioTrackList" "\0"
  /*   477 */ "AudioWorklet" "\0"
  /*   490 */ "AudioWorkletGlobalScope" "\0"
  /*   514 */ "AudioWorkletNode" "\0"
  /*   531 */ "AudioWorkletProcessor" "\0"
  /*   553 */ "AuthenticatorAssertionResponse" "\0"
  /*   584 */ "AuthenticatorAttestationResponse" "\0"
  /*   617 */ "AuthenticatorResponse" "\0"
  /*   639 */ "BarProp" "\0"
  /*   647 */ "BaseAudioContext" "\0"
  /*   664 */ "BatteryManager" "\0"
  /*   679 */ "BeforeUnloadEvent" "\0"
  /*   697 */ "BiquadFilterNode" "\0"
  /*   714 */ "Blob" "\0"
  /*   719 */ "BlobEvent" "\0"
  /*   729 */ "BroadcastChannel" "\0"
  /*   746 */ "BrowsingContext" "\0"
  /*   762 */ "BrowsingContextGroup" "\0"
  /*   783 */ "ByteLengthQueuingStrategy" "\0"
  /*   809 */ "CDATASection" "\0"
  /*   822 */ "CSS" "\0"
  /*   826 */ "CSS2Properties" "\0"
  /*   841 */ "CSSAnimation" "\0"
  /*   854 */ "CSSConditionRule" "\0"
  /*   871 */ "CSSContainerRule" "\0"
  /*   888 */ "CSSCounterStyleRule" "\0"
  /*   908 */ "CSSFontFaceRule" "\0"
  /*   924 */ "CSSFontFeatureValuesRule" "\0"
  /*   949 */ "CSSGroupingRule" "\0"
  /*   965 */ "CSSImportRule" "\0"
  /*   979 */ "CSSKeyframeRule" "\0"
  /*   995 */ "CSSKeyframesRule" "\0"
  /*  1012 */ "CSSLayerBlockRule" "\0"
  /*  1030 */ "CSSLayerStatementRule" "\0"
  /*  1052 */ "CSSMediaRule" "\0"
  /*  1065 */ "CSSMozDocumentRule" "\0"
  /*  1084 */ "CSSNamespaceRule" "\0"
  /*  1101 */ "CSSPageRule" "\0"
  /*  1113 */ "CSSPseudoElement" "\0"
  /*  1130 */ "CSSRule" "\0"
  /*  1138 */ "CSSRuleList" "\0"
  /*  1150 */ "CSSScrollTimelineRule" "\0"
  /*  1172 */ "CSSStyleDeclaration" "\0"
  /*  1192 */ "CSSStyleRule" "\0"
  /*  1205 */ "CSSStyleSheet" "\0"
  /*  1219 */ "CSSSupportsRule" "\0"
  /*  1235 */ "CSSTransition" "\0"
  /*  1249 */ "Cache" "\0"
  /*  1255 */ "CacheStorage" "\0"
  /*  1268 */ "CallbackDebuggerNotification" "\0"
  /*  1297 */ "CanonicalBrowsingContext" "\0"
  /*  1322 */ "CanvasCaptureMediaStream" "\0"
  /*  1347 */ "CanvasGradient" "\0"
  /*  1362 */ "CanvasPattern" "\0"
  /*  1376 */ "CanvasRenderingContext2D" "\0"
  /*  1401 */ "CaretPosition" "\0"
  /*  1415 */ "CaretStateChangedEvent" "\0"
  /*  1438 */ "ChannelMergerNode" "\0"
  /*  1456 */ "ChannelSplitterNode" "\0"
  /*  1476 */ "ChannelWrapper" "\0"
  /*  1491 */ "CharacterData" "\0"
  /*  1505 */ "CheckerboardReportService" "\0"
  /*  1531 */ "ChildProcessMessageManager" "\0"
  /*  1558 */ "ChildSHistory" "\0"
  /*  1572 */ "ChromeMessageBroadcaster" "\0"
  /*  1597 */ "ChromeMessageSender" "\0"
  /*  1617 */ "ChromeNodeList" "\0"
  /*  1632 */ "ChromeUtils" "\0"
  /*  1644 */ "ChromeWorker" "\0"
  /*  1657 */ "Client" "\0"
  /*  1664 */ "Clients" "\0"
  /*  1672 */ "Clipboard" "\0"
  /*  1682 */ "ClipboardEvent" "\0"
  /*  1697 */ "ClipboardItem" "\0"
  /*  1711 */ "ClonedErrorHolder" "\0"
  /*  1729 */ "CloseEvent" "\0"
  /*  1740 */ "CommandEvent" "\0"
  /*  1753 */ "Comment" "\0"
  /*  1761 */ "CompositionEvent" "\0"
  /*  1778 */ "ConsoleInstance" "\0"
  /*  1794 */ "ConstantSourceNode" "\0"
  /*  1813 */ "ContentFrameMessageManager" "\0"
  /*  1840 */ "ContentProcessMessageManager" "\0"
  /*  1869 */ "ConvolverNode" "\0"
  /*  1883 */ "CountQueuingStrategy" "\0"
  /*  1904 */ "CreateOfferRequest" "\0"
  /*  1923 */ "Credential" "\0"
  /*  1934 */ "CredentialsContainer" "\0"
  /*  1955 */ "Crypto" "\0"
  /*  1962 */ "CryptoKey" "\0"
  /*  1972 */ "CustomElementRegistry" "\0"
  /*  1994 */ "CustomEvent" "\0"
  /*  2006 */ "DOMException" "\0"
  /*  2019 */ "DOMImplementation" "\0"
  /*  2037 */ "DOMLocalization" "\0"
  /*  2053 */ "DOMMatrix" "\0"
  /*  2063 */ "DOMMatrixReadOnly" "\0"
  /*  2081 */ "DOMParser" "\0"
  /*  2091 */ "DOMPoint" "\0"
  /*  2100 */ "DOMPointReadOnly" "\0"
  /*  2117 */ "DOMQuad" "\0"
  /*  2125 */ "DOMRect" "\0"
  /*  2133 */ "DOMRectList" "\0"
  /*  2145 */ "DOMRectReadOnly" "\0"
  /*  2161 */ "DOMRequest" "\0"
  /*  2172 */ "DOMStringList" "\0"
  /*  2186 */ "DOMStringMap" "\0"
  /*  2199 */ "DOMTokenList" "\0"
  /*  2212 */ "DataTransfer" "\0"
  /*  2225 */ "DataTransferItem" "\0"
  /*  2242 */ "DataTransferItemList" "\0"
  /*  2263 */ "DebuggerNotification" "\0"
  /*  2284 */ "DebuggerNotificationObserver" "\0"
  /*  2313 */ "DedicatedWorkerGlobalScope" "\0"
  /*  2340 */ "DelayNode" "\0"
  /*  2350 */ "DeprecationReportBody" "\0"
  /*  2372 */ "DeviceAcceleration" "\0"
  /*  2391 */ "DeviceLightEvent" "\0"
  /*  2408 */ "DeviceMotionEvent" "\0"
  /*  2426 */ "DeviceOrientationEvent" "\0"
  /*  2449 */ "DeviceRotationRate" "\0"
  /*  2468 */ "Directory" "\0"
  /*  2478 */ "Document" "\0"
  /*  2487 */ "DocumentFragment" "\0"
  /*  2504 */ "DocumentL10n" "\0"
  /*  2517 */ "DocumentTimeline" "\0"
  /*  2534 */ "DocumentType" "\0"
  /*  2547 */ "DominatorTree" "\0"
  /*  2561 */ "DragEvent" "\0"
  /*  2571 */ "DynamicsCompressorNode" "\0"
  /*  2594 */ "EXT_blend_minmax" "\0"
  /*  2611 */ "EXT_color_buffer_float" "\0"
  /*  2634 */ "EXT_color_buffer_half_float" "\0"
  /*  2662 */ "EXT_disjoint_timer_query" "\0"
  /*  2687 */ "EXT_float_blend" "\0"
  /*  2703 */ "EXT_frag_depth" "\0"
  /*  2718 */ "EXT_sRGB" "\0"
  /*  2727 */ "EXT_shader_texture_lod" "\0"
  /*  2750 */ "EXT_texture_compression_bptc" "\0"
  /*  2779 */ "EXT_texture_compression_rgtc" "\0"
  /*  2808 */ "EXT_texture_filter_anisotropic" "\0"
  /*  2839 */ "EXT_texture_norm16" "\0"
  /*  2858 */ "Element" "\0"
  /*  2866 */ "ElementInternals" "\0"
  /*  2883 */ "ErrorEvent" "\0"
  /*  2894 */ "Event" "\0"
  /*  2900 */ "EventCallbackDebuggerNotification" "\0"
  /*  2934 */ "EventCounts" "\0"
  /*  2946 */ "EventSource" "\0"
  /*  2958 */ "EventTarget" "\0"
  /*  2970 */ "Exception" "\0"
  /*  2980 */ "ExtendableEvent" "\0"
  /*  2996 */ "ExtendableMessageEvent" "\0"
  /*  3019 */ "ExtensionAlarms" "\0"
  /*  3035 */ "ExtensionBrowser" "\0"
  /*  3052 */ "ExtensionEventManager" "\0"
  /*  3074 */ "ExtensionMockAPI" "\0"
  /*  3091 */ "ExtensionPort" "\0"
  /*  3105 */ "ExtensionRuntime" "\0"
  /*  3122 */ "ExtensionTest" "\0"
  /*  3136 */ "External" "\0"
  /*  3145 */ "FeaturePolicy" "\0"
  /*  3159 */ "FeaturePolicyViolationReportBody" "\0"
  /*  3192 */ "FetchEvent" "\0"
  /*  3203 */ "FetchObserver" "\0"
  /*  3217 */ "File" "\0"
  /*  3222 */ "FileList" "\0"
  /*  3231 */ "FileReader" "\0"
  /*  3242 */ "FileReaderSync" "\0"
  /*  3257 */ "FileSystem" "\0"
  /*  3268 */ "FileSystemDirectoryEntry" "\0"
  /*  3293 */ "FileSystemDirectoryHandle" "\0"
  /*  3319 */ "FileSystemDirectoryIterator" "\0"
  /*  3347 */ "FileSystemDirectoryReader" "\0"
  /*  3373 */ "FileSystemEntry" "\0"
  /*  3389 */ "FileSystemFileEntry" "\0"
  /*  3409 */ "FileSystemFileHandle" "\0"
  /*  3430 */ "FileSystemHandle" "\0"
  /*  3447 */ "FileSystemSyncAccessHandle" "\0"
  /*  3474 */ "FileSystemWritableFileStream" "\0"
  /*  3503 */ "Flex" "\0"
  /*  3508 */ "FlexItemValues" "\0"
  /*  3523 */ "FlexLineValues" "\0"
  /*  3538 */ "FluentBundle" "\0"
  /*  3551 */ "FluentBundleAsyncIterator" "\0"
  /*  3577 */ "FluentBundleIterator" "\0"
  /*  3598 */ "FluentPattern" "\0"
  /*  3612 */ "FluentResource" "\0"
  /*  3627 */ "FocusEvent" "\0"
  /*  3638 */ "FontFace" "\0"
  /*  3647 */ "FontFaceSet" "\0"
  /*  3659 */ "FontFaceSetIterator" "\0"
  /*  3679 */ "FontFaceSetLoadEvent" "\0"
  /*  3700 */ "FormData" "\0"
  /*  3709 */ "FormData Iterator" "\0"
  /*  3727 */ "FormDataEvent" "\0"
  /*  3741 */ "FrameCrashedEvent" "\0"
  /*  3759 */ "FrameLoader" "\0"
  /*  3771 */ "GPU" "\0"
  /*  3775 */ "GPUAdapter" "\0"
  /*  3786 */ "GPUBindGroup" "\0"
  /*  3799 */ "GPUBindGroupLayout" "\0"
  /*  3818 */ "GPUBuffer" "\0"
  /*  3828 */ "GPUBufferUsage" "\0"
  /*  3843 */ "GPUCanvasContext" "\0"
  /*  3860 */ "GPUColorWrite" "\0"
  /*  3874 */ "GPUCommandBuffer" "\0"
  /*  3891 */ "GPUCommandEncoder" "\0"
  /*  3909 */ "GPUCompilationInfo" "\0"
  /*  3928 */ "GPUCompilationMessage" "\0"
  /*  3950 */ "GPUComputePassEncoder" "\0"
  /*  3972 */ "GPUComputePipeline" "\0"
  /*  3991 */ "GPUDevice" "\0"
  /*  4001 */ "GPUDeviceLostInfo" "\0"
  /*  4019 */ "GPUMapMode" "\0"
  /*  4030 */ "GPUOutOfMemoryError" "\0"
  /*  4050 */ "GPUPipelineLayout" "\0"
  /*  4068 */ "GPUQuerySet" "\0"
  /*  4080 */ "GPUQueue" "\0"
  /*  4089 */ "GPURenderBundle" "\0"
  /*  4105 */ "GPURenderBundleEncoder" "\0"
  /*  4128 */ "GPURenderPassEncoder" "\0"
  /*  4149 */ "GPURenderPipeline" "\0"
  /*  4167 */ "GPUSampler" "\0"
  /*  4178 */ "GPUShaderModule" "\0"
  /*  4194 */ "GPUShaderStage" "\0"
  /*  4209 */ "GPUSupportedFeatures" "\0"
  /*  4230 */ "GPUSupportedLimits" "\0"
  /*  4249 */ "GPUTexture" "\0"
  /*  4260 */ "GPUTextureUsage" "\0"
  /*  4276 */ "GPUTextureView" "\0"
  /*  4291 */ "GPUUncapturedErrorEvent" "\0"
  /*  4315 */ "GPUValidationError" "\0"
  /*  4334 */ "GainNode" "\0"
  /*  4343 */ "Gamepad" "\0"
  /*  4351 */ "GamepadAxisMoveEvent" "\0"
  /*  4372 */ "GamepadButton" "\0"
  /*  4386 */ "GamepadButtonEvent" "\0"
  /*  4405 */ "GamepadEvent" "\0"
  /*  4418 */ "GamepadHapticActuator" "\0"
  /*  4440 */ "GamepadLightIndicator" "\0"
  /*  4462 */ "GamepadPose" "\0"
  /*  4474 */ "GamepadServiceTest" "\0"
  /*  4493 */ "GamepadTouch" "\0"
  /*  4506 */ "Geolocation" "\0"
  /*  4518 */ "GeolocationCoordinates" "\0"
  /*  4541 */ "GeolocationPosition" "\0"
  /*  4561 */ "GeolocationPositionError" "\0"
  /*  4586 */ "GetUserMediaRequest" "\0"
  /*  4606 */ "GleanCategory" "\0"
  /*  4620 */ "GleanImpl" "\0"
  /*  4630 */ "GleanLabeled" "\0"
  /*  4643 */ "GleanPingsImpl" "\0"
  /*  4658 */ "Grid" "\0"
  /*  4663 */ "GridArea" "\0"
  /*  4672 */ "GridDimension" "\0"
  /*  4686 */ "GridLine" "\0"
  /*  4695 */ "GridLines" "\0"
  /*  4705 */ "GridTrack" "\0"
  /*  4715 */ "GridTracks" "\0"
  /*  4726 */ "HTMLAllCollection" "\0"
  /*  4744 */ "HTMLAnchorElement" "\0"
  /*  4762 */ "HTMLAreaElement" "\0"
  /*  4778 */ "HTMLAudioElement" "\0"
  /*  4795 */ "HTMLBRElement" "\0"
  /*  4809 */ "HTMLBaseElement" "\0"
  /*  4825 */ "HTMLBodyElement" "\0"
  /*  4841 */ "HTMLButtonElement" "\0"
  /*  4859 */ "HTMLCanvasElement" "\0"
  /*  4877 */ "HTMLCollection" "\0"
  /*  4892 */ "HTMLDListElement" "\0"
  /*  4909 */ "HTMLDataElement" "\0"
  /*  4925 */ "HTMLDataListElement" "\0"
  /*  4945 */ "HTMLDetailsElement" "\0"
  /*  4964 */ "HTMLDialogElement" "\0"
  /*  4982 */ "HTMLDirectoryElement" "\0"
  /*  5003 */ "HTMLDivElement" "\0"
  /*  5018 */ "HTMLDocument" "\0"
  /*  5031 */ "HTMLElement" "\0"
  /*  5043 */ "HTMLEmbedElement" "\0"
  /*  5060 */ "HTMLFieldSetElement" "\0"
  /*  5080 */ "HTMLFontElement" "\0"
  /*  5096 */ "HTMLFormControlsCollection" "\0"
  /*  5123 */ "HTMLFormElement" "\0"
  /*  5139 */ "HTMLFrameElement" "\0"
  /*  5156 */ "HTMLFrameSetElement" "\0"
  /*  5176 */ "HTMLHRElement" "\0"
  /*  5190 */ "HTMLHeadElement" "\0"
  /*  5206 */ "HTMLHeadingElement" "\0"
  /*  5225 */ "HTMLHtmlElement" "\0"
  /*  5241 */ "HTMLIFrameElement" "\0"
  /*  5259 */ "HTMLImageElement" "\0"
  /*  5276 */ "HTMLInputElement" "\0"
  /*  5293 */ "HTMLLIElement" "\0"
  /*  5307 */ "HTMLLabelElement" "\0"
  /*  5324 */ "HTMLLegendElement" "\0"
  /*  5342 */ "HTMLLinkElement" "\0"
  /*  5358 */ "HTMLMapElement" "\0"
  /*  5373 */ "HTMLMarqueeElement" "\0"
  /*  5392 */ "HTMLMediaElement" "\0"
  /*  5409 */ "HTMLMenuElement" "\0"
  /*  5425 */ "HTMLMetaElement" "\0"
  /*  5441 */ "HTMLMeterElement" "\0"
  /*  5458 */ "HTMLModElement" "\0"
  /*  5473 */ "HTMLOListElement" "\0"
  /*  5490 */ "HTMLObjectElement" "\0"
  /*  5508 */ "HTMLOptGroupElement" "\0"
  /*  5528 */ "HTMLOptionElement" "\0"
  /*  5546 */ "HTMLOptionsCollection" "\0"
  /*  5568 */ "HTMLOutputElement" "\0"
  /*  5586 */ "HTMLParagraphElement" "\0"
  /*  5607 */ "HTMLParamElement" "\0"
  /*  5624 */ "HTMLPictureElement" "\0"
  /*  5643 */ "HTMLPreElement" "\0"
  /*  5658 */ "HTMLProgressElement" "\0"
  /*  5678 */ "HTMLQuoteElement" "\0"
  /*  5695 */ "HTMLScriptElement" "\0"
  /*  5713 */ "HTMLSelectElement" "\0"
  /*  5731 */ "HTMLSlotElement" "\0"
  /*  5747 */ "HTMLSourceElement" "\0"
  /*  5765 */ "HTMLSpanElement" "\0"
  /*  5781 */ "HTMLStyleElement" "\0"
  /*  5798 */ "HTMLTableCaptionElement" "\0"
  /*  5822 */ "HTMLTableCellElement" "\0"
  /*  5843 */ "HTMLTableColElement" "\0"
  /*  5863 */ "HTMLTableElement" "\0"
  /*  5880 */ "HTMLTableRowElement" "\0"
  /*  5900 */ "HTMLTableSectionElement" "\0"
  /*  5924 */ "HTMLTemplateElement" "\0"
  /*  5944 */ "HTMLTextAreaElement" "\0"
  /*  5964 */ "HTMLTimeElement" "\0"
  /*  5980 */ "HTMLTitleElement" "\0"
  /*  5997 */ "HTMLTrackElement" "\0"
  /*  6014 */ "HTMLUListElement" "\0"
  /*  6031 */ "HTMLUnknownElement" "\0"
  /*  6050 */ "HTMLVideoElement" "\0"
  /*  6067 */ "HashChangeEvent" "\0"
  /*  6083 */ "Headers" "\0"
  /*  6091 */ "Headers Iterator" "\0"
  /*  6108 */ "HeapSnapshot" "\0"
  /*  6121 */ "History" "\0"
  /*  6129 */ "IDBCursor" "\0"
  /*  6139 */ "IDBCursorWithValue" "\0"
  /*  6158 */ "IDBDatabase" "\0"
  /*  6170 */ "IDBFactory" "\0"
  /*  6181 */ "IDBFileHandle" "\0"
  /*  6195 */ "IDBFileRequest" "\0"
  /*  6210 */ "IDBIndex" "\0"
  /*  6219 */ "IDBKeyRange" "\0"
  /*  6231 */ "IDBLocaleAwareKeyRange" "\0"
  /*  6254 */ "IDBMutableFile" "\0"
  /*  6269 */ "IDBObjectStore" "\0"
  /*  6284 */ "IDBOpenDBRequest" "\0"
  /*  6301 */ "IDBRequest" "\0"
  /*  6312 */ "IDBTransaction" "\0"
  /*  6327 */ "IDBVersionChangeEvent" "\0"
  /*  6349 */ "IIRFilterNode" "\0"
  /*  6363 */ "IOUtils" "\0"
  /*  6371 */ "IdleDeadline" "\0"
  /*  6384 */ "Image" "\0"
  /*  6390 */ "ImageBitmap" "\0"
  /*  6402 */ "ImageBitmapRenderingContext" "\0"
  /*  6430 */ "ImageCapture" "\0"
  /*  6443 */ "ImageCaptureError" "\0"
  /*  6461 */ "ImageCaptureErrorEvent" "\0"
  /*  6484 */ "ImageData" "\0"
  /*  6494 */ "ImageDocument" "\0"
  /*  6508 */ "InputEvent" "\0"
  /*  6519 */ "InspectorFontFace" "\0"
  /*  6537 */ "InspectorUtils" "\0"
  /*  6552 */ "InstallTriggerImpl" "\0"
  /*  6571 */ "IntersectionObserver" "\0"
  /*  6592 */ "IntersectionObserverEntry" "\0"
  /*  6618 */ "IntlUtils" "\0"
  /*  6628 */ "JSProcessActorChild" "\0"
  /*  6648 */ "JSProcessActorParent" "\0"
  /*  6669 */ "JSWindowActorChild" "\0"
  /*  6688 */ "JSWindowActorParent" "\0"
  /*  6708 */ "KeyEvent" "\0"
  /*  6717 */ "KeyboardEvent" "\0"
  /*  6731 */ "KeyframeEffect" "\0"
  /*  6746 */ "L10nFileSource" "\0"
  /*  6761 */ "L10nOverlays" "\0"
  /*  6774 */ "L10nRegistry" "\0"
  /*  6787 */ "LegacyMozTCPSocket" "\0"
  /*  6806 */ "Localization" "\0"
  /*  6819 */ "Location" "\0"
  /*  6828 */ "Lock" "\0"
  /*  6833 */ "LockManager" "\0"
  /*  6845 */ "MIDIAccess" "\0"
  /*  6856 */ "MIDIConnectionEvent" "\0"
  /*  6876 */ "MIDIInput" "\0"
  /*  6886 */ "MIDIInputMap" "\0"
  /*  6899 */ "MIDIMessageEvent" "\0"
  /*  6916 */ "MIDIOutput" "\0"
  /*  6927 */ "MIDIOutputMap" "\0"
  /*  6941 */ "MIDIPort" "\0"
  /*  6950 */ "MOZ_debug" "\0"
  /*  6960 */ "MatchGlob" "\0"
  /*  6970 */ "MatchPattern" "\0"
  /*  6983 */ "MatchPatternSet" "\0"
  /*  6999 */ "MathMLElement" "\0"
  /*  7013 */ "MediaCapabilities" "\0"
  /*  7031 */ "MediaCapabilitiesInfo" "\0"
  /*  7053 */ "MediaControlService" "\0"
  /*  7073 */ "MediaController" "\0"
  /*  7089 */ "MediaDeviceInfo" "\0"
  /*  7105 */ "MediaDevices" "\0"
  /*  7118 */ "MediaElementAudioSourceNode" "\0"
  /*  7146 */ "MediaEncryptedEvent" "\0"
  /*  7166 */ "MediaError" "\0"
  /*  7177 */ "MediaKeyError" "\0"
  /*  7191 */ "MediaKeyMessageEvent" "\0"
  /*  7212 */ "MediaKeySession" "\0"
  /*  7228 */ "MediaKeyStatusMap" "\0"
  /*  7246 */ "MediaKeyStatusMap Iterator" "\0"
  /*  7273 */ "MediaKeySystemAccess" "\0"
  /*  7294 */ "MediaKeys" "\0"
  /*  7304 */ "MediaList" "\0"
  /*  7314 */ "MediaMetadata" "\0"
  /*  7328 */ "MediaQueryList" "\0"
  /*  7343 */ "MediaQueryListEvent" "\0"
  /*  7363 */ "MediaRecorder" "\0"
  /*  7377 */ "MediaRecorderErrorEvent" "\0"
  /*  7401 */ "MediaSession" "\0"
  /*  7414 */ "MediaSource" "\0"
  /*  7426 */ "MediaStream" "\0"
  /*  7438 */ "MediaStreamAudioDestinationNode" "\0"
  /*  7470 */ "MediaStreamAudioSourceNode" "\0"
  /*  7497 */ "MediaStreamError" "\0"
  /*  7514 */ "MediaStreamEvent" "\0"
  /*  7531 */ "MediaStreamTrack" "\0"
  /*  7548 */ "MediaStreamTrackAudioSourceNode" "\0"
  /*  7580 */ "MediaStreamTrackEvent" "\0"
  /*  7602 */ "MerchantValidationEvent" "\0"
  /*  7626 */ "MessageBroadcaster" "\0"
  /*  7645 */ "MessageChannel" "\0"
  /*  7660 */ "MessageEvent" "\0"
  /*  7673 */ "MessageListenerManager" "\0"
  /*  7696 */ "MessagePort" "\0"
  /*  7708 */ "MessageSender" "\0"
  /*  7722 */ "MimeType" "\0"
  /*  7731 */ "MimeTypeArray" "\0"
  /*  7745 */ "MouseEvent" "\0"
  /*  7756 */ "MouseScrollEvent" "\0"
  /*  7773 */ "MozCanvasPrintState" "\0"
  /*  7793 */ "MozDocumentMatcher" "\0"
  /*  7812 */ "MozDocumentObserver" "\0"
  /*  7832 */ "MozQueryInterface" "\0"
  /*  7850 */ "MozSharedMap" "\0"
  /*  7863 */ "MozSharedMap Iterator" "\0"
  /*  7885 */ "MozSharedMapChangeEvent" "\0"
  /*  7909 */ "MozStorageAsyncStatementParams" "\0"
  /*  7940 */ "MozStorageStatementParams" "\0"
  /*  7966 */ "MozStorageStatementRow" "\0"
  /*  7989 */ "MozWritableSharedMap" "\0"
  /*  8010 */ "MutationEvent" "\0"
  /*  8024 */ "MutationObserver" "\0"
  /*  8041 */ "MutationRecord" "\0"
  /*  8056 */ "NamedNodeMap" "\0"
  /*  8069 */ "NavigationPreloadManager" "\0"
  /*  8094 */ "Navigator" "\0"
  /*  8104 */ "NetworkInformation" "\0"
  /*  8123 */ "Node" "\0"
  /*  8128 */ "NodeFilter" "\0"
  /*  8139 */ "NodeIterator" "\0"
  /*  8152 */ "NodeList" "\0"
  /*  8161 */ "Notification" "\0"
  /*  8174 */ "NotificationEvent" "\0"
  /*  8192 */ "NotifyPaintEvent" "\0"
  /*  8209 */ "OES_draw_buffers_indexed" "\0"
  /*  8234 */ "OES_element_index_uint" "\0"
  /*  8257 */ "OES_fbo_render_mipmap" "\0"
  /*  8279 */ "OES_standard_derivatives" "\0"
  /*  8304 */ "OES_texture_float" "\0"
  /*  8322 */ "OES_texture_float_linear" "\0"
  /*  8347 */ "OES_texture_half_float" "\0"
  /*  8370 */ "OES_texture_half_float_linear" "\0"
  /*  8400 */ "OES_vertex_array_object" "\0"
  /*  8424 */ "OVR_multiview2" "\0"
  /*  8439 */ "OfflineAudioCompletionEvent" "\0"
  /*  8467 */ "OfflineAudioContext" "\0"
  /*  8487 */ "OfflineResourceList" "\0"
  /*  8507 */ "OffscreenCanvas" "\0"
  /*  8523 */ "OffscreenCanvasRenderingContext2D" "\0"
  /*  8557 */ "OnlyForUseInConstructor" "\0"
  /*  8581 */ "Option" "\0"
  /*  8588 */ "OscillatorNode" "\0"
  /*  8603 */ "PageTransitionEvent" "\0"
  /*  8623 */ "PaintRequest" "\0"
  /*  8636 */ "PaintRequestList" "\0"
  /*  8653 */ "PaintWorkletGlobalScope" "\0"
  /*  8677 */ "PannerNode" "\0"
  /*  8688 */ "ParentProcessMessageManager" "\0"
  /*  8716 */ "Path2D" "\0"
  /*  8723 */ "PathUtils" "\0"
  /*  8733 */ "PaymentAddress" "\0"
  /*  8748 */ "PaymentMethodChangeEvent" "\0"
  /*  8773 */ "PaymentRequest" "\0"
  /*  8788 */ "PaymentRequestUpdateEvent" "\0"
  /*  8814 */ "PaymentResponse" "\0"
  /*  8830 */ "PeerConnectionImpl" "\0"
  /*  8849 */ "PeerConnectionObserver" "\0"
  /*  8872 */ "Performance" "\0"
  /*  8884 */ "PerformanceEntry" "\0"
  /*  8901 */ "PerformanceEntryEvent" "\0"
  /*  8923 */ "PerformanceEventTiming" "\0"
  /*  8946 */ "PerformanceMark" "\0"
  /*  8962 */ "PerformanceMeasure" "\0"
  /*  8981 */ "PerformanceNavigation" "\0"
  /*  9003 */ "PerformanceNavigationTiming" "\0"
  /*  9031 */ "PerformanceObserver" "\0"
  /*  9051 */ "PerformanceObserverEntryList" "\0"
  /*  9080 */ "PerformancePaintTiming" "\0"
  /*  9103 */ "PerformanceResourceTiming" "\0"
  /*  9129 */ "PerformanceServerTiming" "\0"
  /*  9153 */ "PerformanceTiming" "\0"
  /*  9171 */ "PeriodicWave" "\0"
  /*  9184 */ "PermissionStatus" "\0"
  /*  9201 */ "Permissions" "\0"
  /*  9213 */ "PlacesBookmark" "\0"
  /*  9228 */ "PlacesBookmarkAddition" "\0"
  /*  9251 */ "PlacesBookmarkChanged" "\0"
  /*  9273 */ "PlacesBookmarkGuid" "\0"
  /*  9292 */ "PlacesBookmarkMoved" "\0"
  /*  9312 */ "PlacesBookmarkRemoved" "\0"
  /*  9334 */ "PlacesBookmarkTags" "\0"
  /*  9353 */ "PlacesBookmarkTime" "\0"
  /*  9372 */ "PlacesBookmarkTitle" "\0"
  /*  9392 */ "PlacesBookmarkUrl" "\0"
  /*  9410 */ "PlacesEvent" "\0"
  /*  9422 */ "PlacesFavicon" "\0"
  /*  9436 */ "PlacesHistoryCleared" "\0"
  /*  9457 */ "PlacesObservers" "\0"
  /*  9473 */ "PlacesPurgeCaches" "\0"
  /*  9491 */ "PlacesRanking" "\0"
  /*  9505 */ "PlacesVisit" "\0"
  /*  9517 */ "PlacesVisitRemoved" "\0"
  /*  9536 */ "PlacesVisitTitle" "\0"
  /*  9553 */ "PlacesWeakCallbackWrapper" "\0"
  /*  9579 */ "Plugin" "\0"
  /*  9586 */ "PluginArray" "\0"
  /*  9598 */ "PluginCrashedEvent" "\0"
  /*  9617 */ "PointerEvent" "\0"
  /*  9630 */ "PopStateEvent" "\0"
  /*  9644 */ "PopupBlockedEvent" "\0"
  /*  9662 */ "PopupPositionedEvent" "\0"
  /*  9683 */ "PositionStateEvent" "\0"
  /*  9702 */ "PrecompiledScript" "\0"
  /*  9720 */ "PrioEncoder" "\0"
  /*  9732 */ "ProcessMessageManager" "\0"
  /*  9754 */ "ProcessingInstruction" "\0"
  /*  9776 */ "ProgressEvent" "\0"
  /*  9790 */ "PromiseDebugging" "\0"
  /*  9807 */ "PromiseNativeHandler" "\0"
  /*  9828 */ "PromiseRejectionEvent" "\0"
  /*  9850 */ "PublicKeyCredential" "\0"
  /*  9870 */ "PushEvent" "\0"
  /*  9880 */ "PushManager" "\0"
  /*  9892 */ "PushManagerImpl" "\0"
  /*  9908 */ "PushMessageData" "\0"
  /*  9924 */ "PushSubscription" "\0"
  /*  9941 */ "PushSubscriptionOptions" "\0"
  /*  9965 */ "RTCCertificate" "\0"
  /*  9980 */ "RTCDTMFSender" "\0"
  /*  9994 */ "RTCDTMFToneChangeEvent" "\0"
  /* 10017 */ "RTCDataChannel" "\0"
  /* 10032 */ "RTCDataChannelEvent" "\0"
  /* 10052 */ "RTCDtlsTransport" "\0"
  /* 10069 */ "RTCIceCandidate" "\0"
  /* 10085 */ "RTCIdentityProviderRegistrar" "\0"
  /* 10114 */ "RTCPeerConnection" "\0"
  /* 10132 */ "RTCPeerConnectionIceEvent" "\0"
  /* 10158 */ "RTCPeerConnectionStatic" "\0"
  /* 10182 */ "RTCRtpReceiver" "\0"
  /* 10197 */ "RTCRtpSender" "\0"
  /* 10210 */ "RTCRtpTransceiver" "\0"
  /* 10228 */ "RTCSessionDescription" "\0"
  /* 10250 */ "RTCStatsReport" "\0"
  /* 10265 */ "RTCTrackEvent" "\0"
  /* 10279 */ "RadioNodeList" "\0"
  /* 10293 */ "Range" "\0"
  /* 10299 */ "ReadableByteStreamController" "\0"
  /* 10328 */ "ReadableStream" "\0"
  /* 10343 */ "ReadableStreamBYOBReader" "\0"
  /* 10368 */ "ReadableStreamBYOBRequest" "\0"
  /* 10394 */ "ReadableStreamDefaultController" "\0"
  /* 10426 */ "ReadableStreamDefaultReader" "\0"
  /* 10454 */ "Report" "\0"
  /* 10461 */ "ReportBody" "\0"
  /* 10472 */ "ReportingObserver" "\0"
  /* 10490 */ "Request" "\0"
  /* 10498 */ "ResizeObserver" "\0"
  /* 10513 */ "ResizeObserverEntry" "\0"
  /* 10533 */ "ResizeObserverSize" "\0"
  /* 10552 */ "Response" "\0"
  /* 10561 */ "SVGAElement" "\0"
  /* 10573 */ "SVGAngle" "\0"
  /* 10582 */ "SVGAnimateElement" "\0"
  /* 10600 */ "SVGAnimateMotionElement" "\0"
  /* 10624 */ "SVGAnimateTransformElement" "\0"
  /* 10651 */ "SVGAnimatedAngle" "\0"
  /* 10668 */ "SVGAnimatedBoolean" "\0"
  /* 10687 */ "SVGAnimatedEnumeration" "\0"
  /* 10710 */ "SVGAnimatedInteger" "\0"
  /* 10729 */ "SVGAnimatedLength" "\0"
  /* 10747 */ "SVGAnimatedLengthList" "\0"
  /* 10769 */ "SVGAnimatedNumber" "\0"
  /* 10787 */ "SVGAnimatedNumberList" "\0"
  /* 10809 */ "SVGAnimatedPreserveAspectRatio" "\0"
  /* 10840 */ "SVGAnimatedRect" "\0"
  /* 10856 */ "SVGAnimatedString" "\0"
  /* 10874 */ "SVGAnimatedTransformList" "\0"
  /* 10899 */ "SVGAnimationElement" "\0"
  /* 10919 */ "SVGCircleElement" "\0"
  /* 10936 */ "SVGClipPathElement" "\0"
  /* 10955 */ "SVGComponentTransferFunctionElement" "\0"
  /* 10991 */ "SVGDefsElement" "\0"
  /* 11006 */ "SVGDescElement" "\0"
  /* 11021 */ "SVGElement" "\0"
  /* 11032 */ "SVGEllipseElement" "\0"
  /* 11050 */ "SVGFEBlendElement" "\0"
  /* 11068 */ "SVGFEColorMatrixElement" "\0"
  /* 11092 */ "SVGFEComponentTransferElement" "\0"
  /* 11122 */ "SVGFECompositeElement" "\0"
  /* 11144 */ "SVGFEConvolveMatrixElement" "\0"
  /* 11171 */ "SVGFEDiffuseLightingElement" "\0"
  /* 11199 */ "SVGFEDisplacementMapElement" "\0"
  /* 11227 */ "SVGFEDistantLightElement" "\0"
  /* 11252 */ "SVGFEDropShadowElement" "\0"
  /* 11275 */ "SVGFEFloodElement" "\0"
  /* 11293 */ "SVGFEFuncAElement" "\0"
  /* 11311 */ "SVGFEFuncBElement" "\0"
  /* 11329 */ "SVGFEFuncGElement" "\0"
  /* 11347 */ "SVGFEFuncRElement" "\0"
  /* 11365 */ "SVGFEGaussianBlurElement" "\0"
  /* 11390 */ "SVGFEImageElement" "\0"
  /* 11408 */ "SVGFEMergeElement" "\0"
  /* 11426 */ "SVGFEMergeNodeElement" "\0"
  /* 11448 */ "SVGFEMorphologyElement" "\0"
  /* 11471 */ "SVGFEOffsetElement" "\0"
  /* 11490 */ "SVGFEPointLightElement" "\0"
  /* 11513 */ "SVGFESpecularLightingElement" "\0"
  /* 11542 */ "SVGFESpotLightElement" "\0"
  /* 11564 */ "SVGFETileElement" "\0"
  /* 11581 */ "SVGFETurbulenceElement" "\0"
  /* 11604 */ "SVGFilterElement" "\0"
  /* 11621 */ "SVGForeignObjectElement" "\0"
  /* 11645 */ "SVGGElement" "\0"
  /* 11657 */ "SVGGeometryElement" "\0"
  /* 11676 */ "SVGGradientElement" "\0"
  /* 11695 */ "SVGGraphicsElement" "\0"
  /* 11714 */ "SVGImageElement" "\0"
  /* 11730 */ "SVGLength" "\0"
  /* 11740 */ "SVGLengthList" "\0"
  /* 11754 */ "SVGLineElement" "\0"
  /* 11769 */ "SVGLinearGradientElement" "\0"
  /* 11794 */ "SVGMPathElement" "\0"
  /* 11810 */ "SVGMarkerElement" "\0"
  /* 11827 */ "SVGMaskElement" "\0"
  /* 11842 */ "SVGMatrix" "\0"
  /* 11852 */ "SVGMetadataElement" "\0"
  /* 11871 */ "SVGNumber" "\0"
  /* 11881 */ "SVGNumberList" "\0"
  /* 11895 */ "SVGPathElement" "\0"
  /* 11910 */ "SVGPathSeg" "\0"
  /* 11921 */ "SVGPathSegArcAbs" "\0"
  /* 11938 */ "SVGPathSegArcRel" "\0"
  /* 11955 */ "SVGPathSegClosePath" "\0"
  /* 11975 */ "SVGPathSegCurvetoCubicAbs" "\0"
  /* 12001 */ "SVGPathSegCurvetoCubicRel" "\0"
  /* 12027 */ "SVGPathSegCurvetoCubicSmoothAbs" "\0"
  /* 12059 */ "SVGPathSegCurvetoCubicSmoothRel" "\0"
  /* 12091 */ "SVGPathSegCurvetoQuadraticAbs" "\0"
  /* 12121 */ "SVGPathSegCurvetoQuadraticRel" "\0"
  /* 12151 */ "SVGPathSegCurvetoQuadraticSmoothAbs" "\0"
  /* 12187 */ "SVGPathSegCurvetoQuadraticSmoothRel" "\0"
  /* 12223 */ "SVGPathSegLinetoAbs" "\0"
  /* 12243 */ "SVGPathSegLinetoHorizontalAbs" "\0"
  /* 12273 */ "SVGPathSegLinetoHorizontalRel" "\0"
  /* 12303 */ "SVGPathSegLinetoRel" "\0"
  /* 12323 */ "SVGPathSegLinetoVerticalAbs" "\0"
  /* 12351 */ "SVGPathSegLinetoVerticalRel" "\0"
  /* 12379 */ "SVGPathSegList" "\0"
  /* 12394 */ "SVGPathSegMovetoAbs" "\0"
  /* 12414 */ "SVGPathSegMovetoRel" "\0"
  /* 12434 */ "SVGPatternElement" "\0"
  /* 12452 */ "SVGPoint" "\0"
  /* 12461 */ "SVGPointList" "\0"
  /* 12474 */ "SVGPolygonElement" "\0"
  /* 12492 */ "SVGPolylineElement" "\0"
  /* 12511 */ "SVGPreserveAspectRatio" "\0"
  /* 12534 */ "SVGRadialGradientElement" "\0"
  /* 12559 */ "SVGRect" "\0"
  /* 12567 */ "SVGRectElement" "\0"
  /* 12582 */ "SVGSVGElement" "\0"
  /* 12596 */ "SVGScriptElement" "\0"
  /* 12613 */ "SVGSetElement" "\0"
  /* 12627 */ "SVGStopElement" "\0"
  /* 12642 */ "SVGStringList" "\0"
  /* 12656 */ "SVGStyleElement" "\0"
  /* 12672 */ "SVGSwitchElement" "\0"
  /* 12689 */ "SVGSymbolElement" "\0"
  /* 12706 */ "SVGTSpanElement" "\0"
  /* 12722 */ "SVGTextContentElement" "\0"
  /* 12744 */ "SVGTextElement" "\0"
  /* 12759 */ "SVGTextPathElement" "\0"
  /* 12778 */ "SVGTextPositioningElement" "\0"
  /* 12804 */ "SVGTitleElement" "\0"
  /* 12820 */ "SVGTransform" "\0"
  /* 12833 */ "SVGTransformList" "\0"
  /* 12850 */ "SVGUnitTypes" "\0"
  /* 12863 */ "SVGUseElement" "\0"
  /* 12877 */ "SVGViewElement" "\0"
  /* 12892 */ "Sanitizer" "\0"
  /* 12902 */ "Scheduler" "\0"
  /* 12912 */ "Screen" "\0"
  /* 12919 */ "ScreenLuminance" "\0"
  /* 12935 */ "ScreenOrientation" "\0"
  /* 12953 */ "ScriptProcessorNode" "\0"
  /* 12973 */ "ScrollAreaEvent" "\0"
  /* 12989 */ "ScrollViewChangeEvent" "\0"
  /* 13011 */ "SecurityPolicyViolationEvent" "\0"
  /* 13040 */ "Selection" "\0"
  /* 13050 */ "ServiceWorker" "\0"
  /* 13064 */ "ServiceWorkerContainer" "\0"
  /* 13087 */ "ServiceWorkerGlobalScope" "\0"
  /* 13112 */ "ServiceWorkerRegistration" "\0"
  /* 13138 */ "SessionStoreFormData" "\0"
  /* 13159 */ "SessionStoreScrollData" "\0"
  /* 13182 */ "SessionStoreUtils" "\0"
  /* 13200 */ "ShadowRealmGlobalScope" "\0"
  /* 13223 */ "ShadowRoot" "\0"
  /* 13234 */ "SharedWorker" "\0"
  /* 13247 */ "SharedWorkerGlobalScope" "\0"
  /* 13271 */ "SimpleGestureEvent" "\0"
  /* 13290 */ "SourceBuffer" "\0"
  /* 13303 */ "SourceBufferList" "\0"
  /* 13320 */ "SpeechGrammar" "\0"
  /* 13334 */ "SpeechGrammarList" "\0"
  /* 13352 */ "SpeechRecognition" "\0"
  /* 13370 */ "SpeechRecognitionAlternative" "\0"
  /* 13399 */ "SpeechRecognitionError" "\0"
  /* 13422 */ "SpeechRecognitionEvent" "\0"
  /* 13445 */ "SpeechRecognitionResult" "\0"
  /* 13469 */ "SpeechRecognitionResultList" "\0"
  /* 13497 */ "SpeechSynthesis" "\0"
  /* 13513 */ "SpeechSynthesisErrorEvent" "\0"
  /* 13539 */ "SpeechSynthesisEvent" "\0"
  /* 13560 */ "SpeechSynthesisUtterance" "\0"
  /* 13585 */ "SpeechSynthesisVoice" "\0"
  /* 13606 */ "StaticRange" "\0"
  /* 13618 */ "StereoPannerNode" "\0"
  /* 13635 */ "Storage" "\0"
  /* 13643 */ "StorageEvent" "\0"
  /* 13656 */ "StorageManager" "\0"
  /* 13671 */ "StreamFilter" "\0"
  /* 13684 */ "StreamFilterDataEvent" "\0"
  /* 13706 */ "StructuredCloneHolder" "\0"
  /* 13728 */ "StructuredCloneTester" "\0"
  /* 13750 */ "StyleSheet" "\0"
  /* 13761 */ "StyleSheetApplicableStateChangeEvent" "\0"
  /* 13798 */ "StyleSheetList" "\0"
  /* 13813 */ "SubmitEvent" "\0"
  /* 13825 */ "SubtleCrypto" "\0"
  /* 13838 */ "SyncMessageSender" "\0"
  /* 13856 */ "SyncReadFile" "\0"
  /* 13869 */ "TCPServerSocket" "\0"
  /* 13885 */ "TCPServerSocketEvent" "\0"
  /* 13906 */ "TCPSocket" "\0"
  /* 13916 */ "TCPSocketErrorEvent" "\0"
  /* 13936 */ "TCPSocketEvent" "\0"
  /* 13951 */ "TaskController" "\0"
  /* 13966 */ "TaskPriorityChangeEvent" "\0"
  /* 13990 */ "TaskSignal" "\0"
  /* 14001 */ "TelemetryStopwatch" "\0"
  /* 14020 */ "TestAttributesOnTypes" "\0"
  /* 14042 */ "TestCEReactionsInterface" "\0"
  /* 14067 */ "TestCImplementedInterface" "\0"
  /* 14093 */ "TestCImplementedInterface2" "\0"
  /* 14120 */ "TestChildInterface" "\0"
  /* 14139 */ "TestConstructorForFuncInterface" "\0"
  /* 14171 */ "TestConstructorForPrefInterface" "\0"
  /* 14203 */ "TestConstructorForSCInterface" "\0"
  /* 14233 */ "TestCppKeywordNamedMethodsInterface" "\0"
  /* 14269 */ "TestDeprecatedInterface" "\0"
  /* 14293 */ "TestExampleInterface" "\0"
  /* 14314 */ "TestExampleProxyInterface" "\0"
  /* 14340 */ "TestExampleThrowingConstructorInterface" "\0"
  /* 14380 */ "TestExampleWorkerInterface" "\0"
  /* 14407 */ "TestFuncConstructorForDifferentFuncInterface" "\0"
  /* 14452 */ "TestFuncConstructorForInterface" "\0"
  /* 14484 */ "TestHTMLConstructorInterface" "\0"
  /* 14513 */ "TestIndexedAndNamedGetterAndSetterInterface" "\0"
  /* 14557 */ "TestIndexedAndNamedGetterInterface" "\0"
  /* 14592 */ "TestIndexedAndNamedSetterInterface" "\0"
  /* 14627 */ "TestIndexedGetterAndSetterAndNamedGetterInterface" "\0"
  /* 14677 */ "TestIndexedGetterInterface" "\0"
  /* 14704 */ "TestIndexedSetterInterface" "\0"
  /* 14731 */ "TestInterface" "\0"
  /* 14745 */ "TestInterfaceWithPromiseConstructorArg" "\0"
  /* 14784 */ "TestJSImplInterface" "\0"
  /* 14804 */ "TestJSImplInterface2" "\0"
  /* 14825 */ "TestJSImplInterface3" "\0"
  /* 14846 */ "TestJSImplInterface4" "\0"
  /* 14867 */ "TestJSImplInterface5" "\0"
  /* 14888 */ "TestJSImplInterface6" "\0"
  /* 14909 */ "TestJSImplNoInterfaceObject" "\0"
  /* 14937 */ "TestNamedDeleterInterface" "\0"
  /* 14963 */ "TestNamedDeleterWithRetvalInterface" "\0"
  /* 14999 */ "TestNamedGetterInterface" "\0"
  /* 15024 */ "TestNamedSetterInterface" "\0"
  /* 15049 */ "TestNamespace" "\0"
  /* 15063 */ "TestNonWrapperCacheInterface" "\0"
  /* 15092 */ "TestParentInterface" "\0"
  /* 15112 */ "TestPrefChromeOnlySCFuncConstructorForInterface" "\0"
  /* 15160 */ "TestPrefConstructorForDifferentPrefInterface" "\0"
  /* 15205 */ "TestPrefConstructorForInterface" "\0"
  /* 15237 */ "TestProtoObjectHackedNamespace" "\0"
  /* 15268 */ "TestRenamedInterface" "\0"
  /* 15289 */ "TestRenamedNamespace" "\0"
  /* 15310 */ "TestSCConstructorForInterface" "\0"
  /* 15340 */ "TestSecureContextInterface" "\0"
  /* 15367 */ "TestThrowingConstructorInterface" "\0"
  /* 15400 */ "TestUtils" "\0"
  /* 15410 */ "TestWorkerExposedInterface" "\0"
  /* 15437 */ "TestingDeprecatedInterface" "\0"
  /* 15464 */ "Text" "\0"
  /* 15469 */ "TextClause" "\0"
  /* 15480 */ "TextDecoder" "\0"
  /* 15492 */ "TextEncoder" "\0"
  /* 15504 */ "TextMetrics" "\0"
  /* 15516 */ "TextTrack" "\0"
  /* 15526 */ "TextTrackCue" "\0"
  /* 15539 */ "TextTrackCueList" "\0"
  /* 15556 */ "TextTrackList" "\0"
  /* 15570 */ "TimeEvent" "\0"
  /* 15580 */ "TimeRanges" "\0"
  /* 15591 */ "Touch" "\0"
  /* 15597 */ "TouchEvent" "\0"
  /* 15608 */ "TouchList" "\0"
  /* 15618 */ "TrackEvent" "\0"
  /* 15629 */ "TransformStream" "\0"
  /* 15645 */ "TransformStreamDefaultController" "\0"
  /* 15678 */ "TransitionEvent" "\0"
  /* 15694 */ "TreeColumn" "\0"
  /* 15705 */ "TreeColumns" "\0"
  /* 15717 */ "TreeContentView" "\0"
  /* 15733 */ "TreeWalker" "\0"
  /* 15744 */ "U2F" "\0"
  /* 15748 */ "UDPMessageEvent" "\0"
  /* 15764 */ "UDPSocket" "\0"
  /* 15774 */ "UIEvent" "\0"
  /* 15782 */ "URL" "\0"
  /* 15786 */ "URLSearchParams" "\0"
  /* 15802 */ "URLSearchParams Iterator" "\0"
  /* 15827 */ "UserInteraction" "\0"
  /* 15843 */ "UserProximityEvent" "\0"
  /* 15862 */ "VRDisplay" "\0"
  /* 15872 */ "VRDisplayCapabilities" "\0"
  /* 15894 */ "VRDisplayEvent" "\0"
  /* 15909 */ "VREyeParameters" "\0"
  /* 15925 */ "VRFieldOfView" "\0"
  /* 15939 */ "VRFrameData" "\0"
  /* 15951 */ "VRMockController" "\0"
  /* 15968 */ "VRMockDisplay" "\0"
  /* 15982 */ "VRPose" "\0"
  /* 15989 */ "VRServiceTest" "\0"
  /* 16003 */ "VRStageParameters" "\0"
  /* 16021 */ "VTTCue" "\0"
  /* 16028 */ "VTTRegion" "\0"
  /* 16038 */ "ValidityState" "\0"
  /* 16052 */ "VideoPlaybackQuality" "\0"
  /* 16073 */ "VideoTrack" "\0"
  /* 16084 */ "VideoTrackList" "\0"
  /* 16099 */ "VisualViewport" "\0"
  /* 16114 */ "WEBGL_color_buffer_float" "\0"
  /* 16139 */ "WEBGL_compressed_texture_astc" "\0"
  /* 16169 */ "WEBGL_compressed_texture_etc" "\0"
  /* 16198 */ "WEBGL_compressed_texture_etc1" "\0"
  /* 16228 */ "WEBGL_compressed_texture_pvrtc" "\0"
  /* 16259 */ "WEBGL_compressed_texture_s3tc" "\0"
  /* 16289 */ "WEBGL_compressed_texture_s3tc_srgb" "\0"
  /* 16324 */ "WEBGL_debug_renderer_info" "\0"
  /* 16350 */ "WEBGL_debug_shaders" "\0"
  /* 16370 */ "WEBGL_depth_texture" "\0"
  /* 16390 */ "WEBGL_draw_buffers" "\0"
  /* 16409 */ "WEBGL_explicit_present" "\0"
  /* 16432 */ "WEBGL_lose_context" "\0"
  /* 16451 */ "WaveShaperNode" "\0"
  /* 16466 */ "WebExtensionContentScript" "\0"
  /* 16492 */ "WebExtensionPolicy" "\0"
  /* 16511 */ "WebGL2RenderingContext" "\0"
  /* 16534 */ "WebGLActiveInfo" "\0"
  /* 16550 */ "WebGLBuffer" "\0"
  /* 16562 */ "WebGLContextEvent" "\0"
  /* 16580 */ "WebGLFramebuffer" "\0"
  /* 16597 */ "WebGLProgram" "\0"
  /* 16610 */ "WebGLQuery" "\0"
  /* 16621 */ "WebGLRenderbuffer" "\0"
  /* 16639 */ "WebGLRenderingContext" "\0"
  /* 16661 */ "WebGLSampler" "\0"
  /* 16674 */ "WebGLShader" "\0"
  /* 16686 */ "WebGLShaderPrecisionFormat" "\0"
  /* 16713 */ "WebGLSync" "\0"
  /* 16723 */ "WebGLTexture" "\0"
  /* 16736 */ "WebGLTransformFeedback" "\0"
  /* 16759 */ "WebGLUniformLocation" "\0"
  /* 16780 */ "WebGLVertexArrayObject" "\0"
  /* 16803 */ "WebKitCSSMatrix" "\0"
  /* 16819 */ "WebSocket" "\0"
  /* 16829 */ "WebrtcGlobalInformation" "\0"
  /* 16853 */ "WheelEvent" "\0"
  /* 16864 */ "Window" "\0"
  /* 16871 */ "WindowClient" "\0"
  /* 16884 */ "WindowContext" "\0"
  /* 16898 */ "WindowGlobalChild" "\0"
  /* 16916 */ "WindowGlobalParent" "\0"
  /* 16935 */ "WindowRoot" "\0"
  /* 16946 */ "Worker" "\0"
  /* 16953 */ "WorkerDebuggerGlobalScope" "\0"
  /* 16979 */ "WorkerGlobalScope" "\0"
  /* 16997 */ "WorkerLocation" "\0"
  /* 17012 */ "WorkerNavigator" "\0"
  /* 17028 */ "WorkerTestUtils" "\0"
  /* 17044 */ "Worklet" "\0"
  /* 17052 */ "WorkletGlobalScope" "\0"
  /* 17071 */ "WritableStream" "\0"
  /* 17086 */ "WritableStreamDefaultController" "\0"
  /* 17118 */ "WritableStreamDefaultWriter" "\0"
  /* 17146 */ "XMLDocument" "\0"
  /* 17158 */ "XMLHttpRequest" "\0"
  /* 17173 */ "XMLHttpRequestEventTarget" "\0"
  /* 17199 */ "XMLHttpRequestUpload" "\0"
  /* 17220 */ "XMLSerializer" "\0"
  /* 17234 */ "XPathEvaluator" "\0"
  /* 17249 */ "XPathExpression" "\0"
  /* 17265 */ "XPathResult" "\0"
  /* 17277 */ "XRBoundedReferenceSpace" "\0"
  /* 17301 */ "XRFrame" "\0"
  /* 17309 */ "XRInputSource" "\0"
  /* 17323 */ "XRInputSourceArray" "\0"
  /* 17342 */ "XRInputSourceEvent" "\0"
  /* 17361 */ "XRInputSourcesChangeEvent" "\0"
  /* 17387 */ "XRPose" "\0"
  /* 17394 */ "XRReferenceSpace" "\0"
  /* 17411 */ "XRReferenceSpaceEvent" "\0"
  /* 17433 */ "XRRenderState" "\0"
  /* 17447 */ "XRRigidTransform" "\0"
  /* 17464 */ "XRSession" "\0"
  /* 17474 */ "XRSessionEvent" "\0"
  /* 17489 */ "XRSpace" "\0"
  /* 17497 */ "XRSystem" "\0"
  /* 17506 */ "XRView" "\0"
  /* 17513 */ "XRViewerPose" "\0"
  /* 17526 */ "XRViewport" "\0"
  /* 17537 */ "XRWebGLLayer" "\0"
  /* 17550 */ "XSLTProcessor" "\0"
  /* 17564 */ "XULCommandEvent" "\0"
  /* 17580 */ "XULElement" "\0"
  /* 17591 */ "XULFrameElement" "\0"
  /* 17607 */ "XULMenuElement" "\0"
  /* 17622 */ "XULPopupElement" "\0"
  /* 17638 */ "XULResizerElement" "\0"
  /* 17656 */ "XULTextElement" "\0"
  /* 17671 */ "XULTreeElement" "\0"
  /* 17686 */ "console" "\0"
  /* 17694 */ "mozRTCIceCandidate" "\0"
  /* 17713 */ "mozRTCPeerConnection" "\0"
  /* 17734 */ "mozRTCSessionDescription" "\0"
  /* 17759 */ "webkitSpeechGrammar" "\0"
  /* 17779 */ "webkitSpeechGrammarList" "\0"
  /* 17803 */ "webkitSpeechRecognition" "\0"
  /* 17827 */ "webkitURL"
};

}  // namespace binding_detail

// Making this enum bigger than a uint16_t has consequences on the size
// of some structs (eg. WebIDLNameTableEntry) and tables. We should try
// to avoid that.
static_assert(EnumTypeFitsWithin<BindingNamesOffset, uint16_t>::value,
              "Size increase");

} // namespace mozilla::dom

