//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/ipc/PBackgroundParent.h"
#include "mozilla/ipc/PBackgroundChild.h"
#include "mozilla/dom/POriginPrivateFileSystemParent.h"
#include "mozilla/dom/POriginPrivateFileSystemChild.h"
#include "mozilla/dom/PBackgroundFileSystem.h"
#include "mozilla/dom/PBackgroundFileSystemParent.h"
#include "mozilla/dom/PBackgroundFileSystemChild.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace dom {
namespace PBackgroundFileSystem {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::PBackgroundFileSystemParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::PBackgroundFileSystemChild>* aChild)
{
    return mozilla::ipc::CreateEndpoints(
        mozilla::ipc::PrivateIPDLInterface(),
        aParentDestPid, aChildDestPid, aParent, aChild);
}
mozilla::UniquePtr<IPC::Message>
Msg_GetRoot(int32_t routingId)
{
    return IPC::Message::IPDLMessage(routingId, Msg_GetRoot__ID, 0, IPC::Message::HeaderFlags(IPC::Message::NOT_NESTED, IPC::Message::NORMAL_PRIORITY, IPC::Message::COMPRESSION_NONE, IPC::Message::NOT_CONSTRUCTOR, IPC::Message::ASYNC, IPC::Message::NOT_REPLY));
}
mozilla::UniquePtr<IPC::Message>
Reply_GetRoot(int32_t routingId)
{
    return IPC::Message::IPDLMessage(routingId, Reply_GetRoot__ID, 0, IPC::Message::HeaderFlags(IPC::Message::NOT_NESTED, IPC::Message::NORMAL_PRIORITY, IPC::Message::COMPRESSION_NONE, IPC::Message::NOT_CONSTRUCTOR, IPC::Message::ASYNC, IPC::Message::REPLY));
}
mozilla::UniquePtr<IPC::Message>
Msg___delete__(int32_t routingId)
{
    return IPC::Message::IPDLMessage(routingId, Msg___delete____ID, 0, IPC::Message::HeaderFlags(IPC::Message::NOT_NESTED, IPC::Message::NORMAL_PRIORITY, IPC::Message::COMPRESSION_NONE, IPC::Message::NOT_CONSTRUCTOR, IPC::Message::ASYNC, IPC::Message::NOT_REPLY));
}
mozilla::UniquePtr<IPC::Message>
Reply___delete__(int32_t routingId)
{
    return IPC::Message::IPDLMessage(routingId, Reply___delete____ID, 0, IPC::Message::HeaderFlags(IPC::Message::NOT_NESTED, IPC::Message::NORMAL_PRIORITY, IPC::Message::COMPRESSION_NONE, IPC::Message::NOT_CONSTRUCTOR, IPC::Message::ASYNC, IPC::Message::REPLY));
}

} // namespace PBackgroundFileSystem
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union FileSystemGetRootResponse|
//
namespace mozilla {
namespace dom {
namespace fs {
auto FileSystemGetRootResponse::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case Tnsresult:
        {
            (ptr_nsresult())->~nsresult__tdef();
            break;
        }
    case TEntryId:
        {
            (ptr_EntryId())->~EntryId__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT FileSystemGetRootResponse::FileSystemGetRootResponse(const nsresult& aOther)
{
    new (mozilla::KnownNotNull, ptr_nsresult()) nsresult(aOther);
    mType = Tnsresult;
}

MOZ_IMPLICIT FileSystemGetRootResponse::FileSystemGetRootResponse(nsresult&& aOther)
{
    new (mozilla::KnownNotNull, ptr_nsresult()) nsresult(std::move(aOther));
    mType = Tnsresult;
}

MOZ_IMPLICIT FileSystemGetRootResponse::FileSystemGetRootResponse(const EntryId& aOther)
{
    new (mozilla::KnownNotNull, ptr_EntryId()) EntryId(aOther);
    mType = TEntryId;
}

MOZ_IMPLICIT FileSystemGetRootResponse::FileSystemGetRootResponse(EntryId&& aOther)
{
    new (mozilla::KnownNotNull, ptr_EntryId()) EntryId(std::move(aOther));
    mType = TEntryId;
}

MOZ_IMPLICIT FileSystemGetRootResponse::FileSystemGetRootResponse(const FileSystemGetRootResponse& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case Tnsresult:
        {
            new (mozilla::KnownNotNull, ptr_nsresult()) nsresult((aOther).get_nsresult());
            break;
        }
    case TEntryId:
        {
            new (mozilla::KnownNotNull, ptr_EntryId()) EntryId((aOther).get_EntryId());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MOZ_IMPLICIT FileSystemGetRootResponse::FileSystemGetRootResponse(FileSystemGetRootResponse&& aOther)
{
    (aOther).AssertSanity();
    Type t = (aOther).type();
    switch (t) {
    case Tnsresult:
        {
            new (mozilla::KnownNotNull, ptr_nsresult()) nsresult(std::move((aOther).get_nsresult()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TEntryId:
        {
            new (mozilla::KnownNotNull, ptr_EntryId()) EntryId(std::move((aOther).get_EntryId()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    (aOther).mType = T__None;
    mType = t;
}

FileSystemGetRootResponse::~FileSystemGetRootResponse()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto FileSystemGetRootResponse::operator=(const nsresult& aRhs) -> FileSystemGetRootResponse&
{
    if (MaybeDestroy(Tnsresult)) {
        new (mozilla::KnownNotNull, ptr_nsresult()) nsresult;
    }
    (*(ptr_nsresult())) = aRhs;
    mType = Tnsresult;
    return (*(this));
}

auto FileSystemGetRootResponse::operator=(nsresult&& aRhs) -> FileSystemGetRootResponse&
{
    if (MaybeDestroy(Tnsresult)) {
        new (mozilla::KnownNotNull, ptr_nsresult()) nsresult;
    }
    (*(ptr_nsresult())) = std::move(aRhs);
    mType = Tnsresult;
    return (*(this));
}

auto FileSystemGetRootResponse::operator=(const EntryId& aRhs) -> FileSystemGetRootResponse&
{
    if (MaybeDestroy(TEntryId)) {
        new (mozilla::KnownNotNull, ptr_EntryId()) EntryId;
    }
    (*(ptr_EntryId())) = aRhs;
    mType = TEntryId;
    return (*(this));
}

auto FileSystemGetRootResponse::operator=(EntryId&& aRhs) -> FileSystemGetRootResponse&
{
    if (MaybeDestroy(TEntryId)) {
        new (mozilla::KnownNotNull, ptr_EntryId()) EntryId;
    }
    (*(ptr_EntryId())) = std::move(aRhs);
    mType = TEntryId;
    return (*(this));
}

auto FileSystemGetRootResponse::operator=(const FileSystemGetRootResponse& aRhs) -> FileSystemGetRootResponse&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case Tnsresult:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_nsresult()) nsresult;
            }
            (*(ptr_nsresult())) = (aRhs).get_nsresult();
            break;
        }
    case TEntryId:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_EntryId()) EntryId;
            }
            (*(ptr_EntryId())) = (aRhs).get_EntryId();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto FileSystemGetRootResponse::operator=(FileSystemGetRootResponse&& aRhs) -> FileSystemGetRootResponse&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case Tnsresult:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_nsresult()) nsresult;
            }
            (*(ptr_nsresult())) = std::move((aRhs).get_nsresult());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TEntryId:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_EntryId()) EntryId;
            }
            (*(ptr_EntryId())) = std::move((aRhs).get_EntryId());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    (aRhs).mType = T__None;
    mType = t;
    return (*(this));
}

} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
auto ParamTraits<mozilla::dom::fs::FileSystemGetRootResponse>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    typedef mozilla::dom::fs::FileSystemGetRootResponse union__;
    int type = (aVar).type();
    IPC::WriteParam(aWriter, type);
    // Sentinel = 'FileSystemGetRootResponse'
    (aWriter)->WriteSentinel(2160200217);

    switch (type) {
    case union__::Tnsresult:
        {
            IPC::WriteParam(aWriter, (aVar).get_nsresult());
            // Sentinel = 'Tnsresult'
            (aWriter)->WriteSentinel(313394133);
            return;
        }
    case union__::TEntryId:
        {
            IPC::WriteParam(aWriter, (aVar).get_EntryId());
            // Sentinel = 'TEntryId'
            (aWriter)->WriteSentinel(227279636);
            return;
        }
    default:
        {
            aWriter->FatalError("unknown union type");
            return;
        }
    }
}

auto ParamTraits<mozilla::dom::fs::FileSystemGetRootResponse>::Read(
        IPC::MessageReader* aReader,
        paramType* aVar) -> bool
{
    typedef mozilla::dom::fs::FileSystemGetRootResponse union__;
    int type = 0;
    if ((!(IPC::ReadParam(aReader, (&(type)))))) {
        aReader->FatalError("Error deserializing type of union FileSystemGetRootResponse");
        return false;
    }
    // Sentinel = 'FileSystemGetRootResponse'
    if ((!((aReader)->ReadSentinel(2160200217)))) {
        mozilla::ipc::SentinelReadError("Error deserializing type of union FileSystemGetRootResponse");
        return false;
    }

    switch (type) {
    case union__::Tnsresult:
        {
            nsresult tmp = nsresult();
            (*(aVar)) = std::move(tmp);
            if ((!(IPC::ReadParam(aReader, (&((aVar)->get_nsresult())))))) {
                aReader->FatalError("Error deserializing variant Tnsresult of union FileSystemGetRootResponse");
                return false;
            }
            // Sentinel = 'Tnsresult'
            if ((!((aReader)->ReadSentinel(313394133)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant Tnsresult of union FileSystemGetRootResponse");
                return false;
            }
            return true;
        }
    case union__::TEntryId:
        {
            mozilla::dom::fs::EntryId tmp = mozilla::dom::fs::EntryId();
            (*(aVar)) = std::move(tmp);
            if ((!(IPC::ReadParam(aReader, (&((aVar)->get_EntryId())))))) {
                aReader->FatalError("Error deserializing variant TEntryId of union FileSystemGetRootResponse");
                return false;
            }
            // Sentinel = 'TEntryId'
            if ((!((aReader)->ReadSentinel(227279636)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant TEntryId of union FileSystemGetRootResponse");
                return false;
            }
            return true;
        }
    default:
        {
            aReader->FatalError("unknown union type");
            return false;
        }
    }
}

} // namespace IPC
