//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/PBackgroundFileSystemParent.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/dom/BackgroundFileSystemParent.h"

#include "mozilla/ipc/PBackgroundParent.h"
#include "mozilla/dom/POriginPrivateFileSystemParent.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace dom {


MOZ_IMPLICIT PBackgroundFileSystemParent::PBackgroundFileSystemParent() :
    mozilla::ipc::IProtocol(PBackgroundFileSystemMsgStart, mozilla::ipc::ParentSide)
{
    MOZ_COUNT_CTOR(PBackgroundFileSystemParent);
}

PBackgroundFileSystemParent::~PBackgroundFileSystemParent()
{
    MOZ_COUNT_DTOR(PBackgroundFileSystemParent);
}

auto PBackgroundFileSystemParent::OtherPid() const -> ::base::ProcessId
{
    ::base::ProcessId pid =
        ::mozilla::ipc::IProtocol::ToplevelProtocol()->OtherPidMaybeInvalid();
    MOZ_RELEASE_ASSERT(pid != ::base::kInvalidProcessId);
    return pid;
}

auto PBackgroundFileSystemParent::Manager() const -> PBackgroundParent*
{
    return static_cast<PBackgroundParent*>(IProtocol::Manager());
}

auto PBackgroundFileSystemParent::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    arr__.SetCapacity(total);

}

auto PBackgroundFileSystemParent::Send__delete__(PBackgroundFileSystemParent* actor) -> bool
{
    if (!actor || !actor->CanSend()) {
        NS_WARNING("Attempt to __delete__ missing or closed actor");
        return false;
    }
    UniquePtr<IPC::Message> msg__ = PBackgroundFileSystem::Msg___delete__((actor)->Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            actor};

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    IPC::WriteParam((&(writer__)), actor);
    // Sentinel = 'actor'
    ((&(writer__)))->WriteSentinel(102892058);



    if (mozilla::ipc::LoggingEnabledFor("PBackgroundFileSystemParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PBackgroundFileSystemParent",
            actor->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PBackgroundFileSystem::Msg___delete__", OTHER);

    bool sendok__ = (actor)->ChannelSend(std::move(msg__));

    IProtocol* mgr = actor->Manager();
    actor->DestroySubtree(Deletion);
    actor->ClearSubtree();
    mgr->RemoveManagee(PBackgroundFileSystemMsgStart, actor);
    return sendok__;
}

auto PBackgroundFileSystemParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PBackgroundFileSystemParent::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PBackgroundFileSystemParent::OnMessageReceived(const Message& msg__) -> PBackgroundFileSystemParent::Result
{
    switch (msg__.type()) {
    case MANAGED_ENDPOINT_BOUND_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            return MsgProcessed;
        }
    case MANAGED_ENDPOINT_DROPPED_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            IProtocol* mgr = this->Manager();
            this->DestroySubtree(ManagedEndpointDropped);
            this->ClearSubtree();
            mgr->RemoveManagee(PBackgroundFileSystemMsgStart, this);
            return MsgProcessed;
        }
    case PBackgroundFileSystem::Msg_GetRoot__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PBackgroundFileSystemParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PBackgroundFileSystemParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PBackgroundFileSystem::Msg_GetRoot", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            Endpoint<mozilla::dom::POriginPrivateFileSystemParent> aParentEP{};

            if ((!(IPC::ReadParam((&(reader__)), (&(aParentEP)))))) {
                FatalError("Error deserializing 'Endpoint<mozilla::dom::POriginPrivateFileSystemParent>'");
                return MsgValueError;
            }
            // Sentinel = 'aParentEP'
            if ((!(((&(reader__)))->ReadSentinel(288097121)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'Endpoint<mozilla::dom::POriginPrivateFileSystemParent>'");
                return MsgValueError;
            }
            reader__.EndRead();
            int32_t id__ = Id();
            UniquePtr<IPC::Message> reply__(PBackgroundFileSystem::Reply_GetRoot(id__));
            reply__->set_seqno(msg__.seqno());

            RefPtr<mozilla::ipc::IPDLResolverInner> resolver__ =
                new mozilla::ipc::IPDLResolverInner(std::move(reply__), this);

            GetRootResolver resolver = [resolver__ = std::move(resolver__)](const FileSystemGetRootResponse& aParam) {
                resolver__->Resolve([&] (IPC::Message* reply__, IProtocol* self__) {
                    IPC::MessageWriter writer__(*reply__, self__);
                    IPC::WriteParam((&(writer__)), aParam);
                    // Sentinel = 'handle'
                    ((&(writer__)))->WriteSentinel(142344813);

                    if (mozilla::ipc::LoggingEnabledFor("PBackgroundFileSystemParent")) {
                        mozilla::ipc::LogMessageForProtocol(
                            "PBackgroundFileSystemParent",
                            self__->ToplevelProtocol()->OtherPidMaybeInvalid(),
                            "Sending reply ",
                            reply__->type(),
                            mozilla::ipc::MessageDirection::eSending);
                    }

                });
            };
            mozilla::ipc::IPCResult __ok = (static_cast<BackgroundFileSystemParent*>(this))->RecvGetRoot(std::move(aParentEP), std::move(resolver));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PBackgroundFileSystem::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PBackgroundFileSystemParent::OnMessageReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PBackgroundFileSystemParent::Result
{
    return MsgNotKnown;
}

auto PBackgroundFileSystemParent::OnCallReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PBackgroundFileSystemParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PBackgroundFileSystemParent::ClearSubtree() -> void
{
}



} // namespace dom
} // namespace mozilla
namespace IPC {
auto ParamTraits<mozilla::dom::PBackgroundFileSystemParent*>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    MOZ_RELEASE_ASSERT(
        aWriter->GetActor(),
        "Cannot serialize managed actors without an actor");

    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aWriter->GetActor()->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    IPC::WriteParam(aWriter, id);
}

auto ParamTraits<mozilla::dom::PBackgroundFileSystemParent*>::Read(
        IPC::MessageReader* aReader,
        paramType* aVar) -> bool
{
    MOZ_RELEASE_ASSERT(
        aReader->GetActor(),
        "Cannot deserialize managed actors without an actor");

    mozilla::Maybe<mozilla::ipc::IProtocol*> actor =
        aReader->GetActor()->ReadActor(aReader, true, "PBackgroundFileSystem", PBackgroundFileSystemMsgStart);
    if (actor.isNothing()) {
        return false;
    }

    *aVar = static_cast<mozilla::dom::PBackgroundFileSystemParent*>(actor.value());
    return true;
}

} // namespace IPC
