//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PBackgroundFileSystem_h
#define PBackgroundFileSystem_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "nsTHashtable.h"
#include "mozilla/MozPromise.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"
#include "mozilla/ipc/ByteBuf.h"
#include "mozilla/ipc/FileDescriptor.h"
#include "mozilla/ipc/ProtocolUtilsFwd.h"
#include "mozilla/ipc/Shmem.h"

// Headers for typedefs
#include "mozilla/dom/FileSystemTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FileSystemGetRootResponse|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemGetRootResponse final
{
public:
    enum Type {
        T__None,
        Tnsresult = 1,
        TEntryId,
        T__Last = TEntryId
    };

private:
    typedef mozilla::dom::fs::EntryId EntryId;
    typedef nsresult nsresult__tdef;
    typedef EntryId EntryId__tdef;

    union Value {
        mozilla::AlignedStorage2<nsresult> Vnsresult;
        mozilla::AlignedStorage2<EntryId> VEntryId;
    };

    nsresult*
    ptr_nsresult()
    {
        return ((mValue).Vnsresult).addr();
    }
    const nsresult*
    constptr_nsresult() const
    {
        return ((mValue).Vnsresult).addr();
    }
    EntryId*
    ptr_EntryId()
    {
        return ((mValue).VEntryId).addr();
    }
    const EntryId*
    constptr_EntryId() const
    {
        return ((mValue).VEntryId).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FileSystemGetRootResponse() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FileSystemGetRootResponse(const nsresult& aOther);

    MOZ_IMPLICIT FileSystemGetRootResponse(nsresult&& aOther);

    MOZ_IMPLICIT FileSystemGetRootResponse(const EntryId& aOther);

    MOZ_IMPLICIT FileSystemGetRootResponse(EntryId&& aOther);

    MOZ_IMPLICIT FileSystemGetRootResponse(const FileSystemGetRootResponse& aOther);

    MOZ_IMPLICIT FileSystemGetRootResponse(FileSystemGetRootResponse&& aOther);

    ~FileSystemGetRootResponse();

    Type
    type() const
    {
        return mType;
    }

    FileSystemGetRootResponse&
    operator=(const nsresult& aRhs);

    FileSystemGetRootResponse&
    operator=(nsresult&& aRhs);

    FileSystemGetRootResponse&
    operator=(const EntryId& aRhs);

    FileSystemGetRootResponse&
    operator=(EntryId&& aRhs);

    FileSystemGetRootResponse&
    operator=(const FileSystemGetRootResponse& aRhs);

    FileSystemGetRootResponse&
    operator=(FileSystemGetRootResponse&& aRhs);

    nsresult&
    get_nsresult()
    {
        AssertSanity(Tnsresult);
        return (*(ptr_nsresult()));
    }
    const nsresult&
    get_nsresult() const
    {
        AssertSanity(Tnsresult);
        return (*(constptr_nsresult()));
    }
    operator nsresult&()
    {
        return get_nsresult();
    }
    operator const nsresult&() const
    {
        return get_nsresult();
    }

    EntryId&
    get_EntryId()
    {
        AssertSanity(TEntryId);
        return (*(ptr_EntryId()));
    }
    const EntryId&
    get_EntryId() const
    {
        AssertSanity(TEntryId);
        return (*(constptr_EntryId()));
    }
    operator EntryId&()
    {
        return get_EntryId();
    }
    operator const EntryId&() const
    {
        return get_EntryId();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemGetRootResponse>
{
    typedef mozilla::dom::fs::FileSystemGetRootResponse paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC

namespace mozilla {
namespace dom {
class PBackgroundFileSystemParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBackgroundFileSystemChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PBackgroundFileSystemChild and PBackgroundFileSystemParent
//
namespace mozilla {
namespace dom {
namespace PBackgroundFileSystem {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::PBackgroundFileSystemParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::PBackgroundFileSystemChild>* aChild);

enum MessageType {
    PBackgroundFileSystemStart = PBackgroundFileSystemMsgStart << 16,
    Msg_GetRoot__ID,
    Reply_GetRoot__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PBackgroundFileSystemEnd
};

mozilla::UniquePtr<IPC::Message>
Msg_GetRoot(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_GetRoot(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg___delete__(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply___delete__(int32_t routingId);



} // namespace PBackgroundFileSystem
} // namespace dom
} // namespace mozilla

#endif // ifndef PBackgroundFileSystem_h
