//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef POriginPrivateFileSystem_h
#define POriginPrivateFileSystem_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "nsTHashtable.h"
#include "mozilla/MozPromise.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"
#include "mozilla/ipc/ByteBuf.h"
#include "mozilla/ipc/FileDescriptor.h"
#include "mozilla/ipc/ProtocolUtilsFwd.h"
#include "mozilla/ipc/Shmem.h"

// Headers for typedefs
#include "mozilla/dom/FileSystemTypes.h"
#include "mozilla/ipc/IPCCore.h"
#include "mozilla/dom/IPCBlob.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemEntryMetadata|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemEntryMetadata final
{
private:
    typedef mozilla::dom::fs::EntryId EntryId;
    typedef mozilla::dom::fs::Name Name;

public:
    MOZ_IMPLICIT FileSystemEntryMetadata() :
        entryId_(),
        entryName_()
    {
    }

    MOZ_IMPLICIT FileSystemEntryMetadata(
            const EntryId& _entryId,
            const Name& _entryName) :
        entryId_(_entryId),
        entryName_(_entryName)
    {
    }

    EntryId&
    entryId()
    {
        return entryId_;
    }
    const EntryId&
    entryId() const
    {
        return entryId_;
    }

    Name&
    entryName()
    {
        return entryName_;
    }
    const Name&
    entryName() const
    {
        return entryName_;
    }

private:
    EntryId entryId_;
    Name entryName_;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemEntryMetadata>
{
    typedef mozilla::dom::fs::FileSystemEntryMetadata paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemChildMetadata|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemChildMetadata final
{
private:
    typedef mozilla::dom::fs::EntryId EntryId;
    typedef mozilla::dom::fs::Name Name;

public:
    MOZ_IMPLICIT FileSystemChildMetadata() :
        parentId_(),
        childName_()
    {
    }

    MOZ_IMPLICIT FileSystemChildMetadata(
            const EntryId& _parentId,
            const Name& _childName) :
        parentId_(_parentId),
        childName_(_childName)
    {
    }

    EntryId&
    parentId()
    {
        return parentId_;
    }
    const EntryId&
    parentId() const
    {
        return parentId_;
    }

    Name&
    childName()
    {
        return childName_;
    }
    const Name&
    childName() const
    {
        return childName_;
    }

private:
    EntryId parentId_;
    Name childName_;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemChildMetadata>
{
    typedef mozilla::dom::fs::FileSystemChildMetadata paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemGetHandleRequest|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemGetHandleRequest final
{
private:
    typedef mozilla::dom::fs::FileSystemChildMetadata FileSystemChildMetadata;

public:
    MOZ_IMPLICIT FileSystemGetHandleRequest() :
        handle_(),
        create_()
    {
    }

    MOZ_IMPLICIT FileSystemGetHandleRequest(
            const FileSystemChildMetadata& _handle,
            const bool& _create) :
        handle_(_handle),
        create_(_create)
    {
    }

    FileSystemChildMetadata&
    handle()
    {
        return handle_;
    }
    const FileSystemChildMetadata&
    handle() const
    {
        return handle_;
    }

    bool&
    create()
    {
        return create_;
    }
    const bool&
    create() const
    {
        return create_;
    }

private:
    FileSystemChildMetadata handle_;
    bool create_;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemGetHandleRequest>
{
    typedef mozilla::dom::fs::FileSystemGetHandleRequest paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FileSystemGetHandleResponse|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemGetHandleResponse final
{
public:
    enum Type {
        T__None,
        Tnsresult = 1,
        TEntryId,
        T__Last = TEntryId
    };

private:
    typedef mozilla::dom::fs::EntryId EntryId;
    typedef nsresult nsresult__tdef;
    typedef EntryId EntryId__tdef;

    union Value {
        mozilla::AlignedStorage2<nsresult> Vnsresult;
        mozilla::AlignedStorage2<EntryId> VEntryId;
    };

    nsresult*
    ptr_nsresult()
    {
        return ((mValue).Vnsresult).addr();
    }
    const nsresult*
    constptr_nsresult() const
    {
        return ((mValue).Vnsresult).addr();
    }
    EntryId*
    ptr_EntryId()
    {
        return ((mValue).VEntryId).addr();
    }
    const EntryId*
    constptr_EntryId() const
    {
        return ((mValue).VEntryId).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FileSystemGetHandleResponse() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FileSystemGetHandleResponse(const nsresult& aOther);

    MOZ_IMPLICIT FileSystemGetHandleResponse(nsresult&& aOther);

    MOZ_IMPLICIT FileSystemGetHandleResponse(const EntryId& aOther);

    MOZ_IMPLICIT FileSystemGetHandleResponse(EntryId&& aOther);

    MOZ_IMPLICIT FileSystemGetHandleResponse(const FileSystemGetHandleResponse& aOther);

    MOZ_IMPLICIT FileSystemGetHandleResponse(FileSystemGetHandleResponse&& aOther);

    ~FileSystemGetHandleResponse();

    Type
    type() const
    {
        return mType;
    }

    FileSystemGetHandleResponse&
    operator=(const nsresult& aRhs);

    FileSystemGetHandleResponse&
    operator=(nsresult&& aRhs);

    FileSystemGetHandleResponse&
    operator=(const EntryId& aRhs);

    FileSystemGetHandleResponse&
    operator=(EntryId&& aRhs);

    FileSystemGetHandleResponse&
    operator=(const FileSystemGetHandleResponse& aRhs);

    FileSystemGetHandleResponse&
    operator=(FileSystemGetHandleResponse&& aRhs);

    nsresult&
    get_nsresult()
    {
        AssertSanity(Tnsresult);
        return (*(ptr_nsresult()));
    }
    const nsresult&
    get_nsresult() const
    {
        AssertSanity(Tnsresult);
        return (*(constptr_nsresult()));
    }
    operator nsresult&()
    {
        return get_nsresult();
    }
    operator const nsresult&() const
    {
        return get_nsresult();
    }

    EntryId&
    get_EntryId()
    {
        AssertSanity(TEntryId);
        return (*(ptr_EntryId()));
    }
    const EntryId&
    get_EntryId() const
    {
        AssertSanity(TEntryId);
        return (*(constptr_EntryId()));
    }
    operator EntryId&()
    {
        return get_EntryId();
    }
    operator const EntryId&() const
    {
        return get_EntryId();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemGetHandleResponse>
{
    typedef mozilla::dom::fs::FileSystemGetHandleResponse paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemGetEntriesRequest|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemGetEntriesRequest final
{
private:
    typedef mozilla::dom::fs::EntryId EntryId;
    typedef mozilla::dom::fs::PageNumber PageNumber;

public:
    MOZ_IMPLICIT FileSystemGetEntriesRequest() :
        parentId_(),
        page_()
    {
    }

    MOZ_IMPLICIT FileSystemGetEntriesRequest(
            const EntryId& _parentId,
            const PageNumber& _page) :
        parentId_(_parentId),
        page_(_page)
    {
    }

    EntryId&
    parentId()
    {
        return parentId_;
    }
    const EntryId&
    parentId() const
    {
        return parentId_;
    }

    PageNumber&
    page()
    {
        return page_;
    }
    const PageNumber&
    page() const
    {
        return page_;
    }

private:
    EntryId parentId_;
    PageNumber page_;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemGetEntriesRequest>
{
    typedef mozilla::dom::fs::FileSystemGetEntriesRequest paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemDirectoryListing|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemDirectoryListing final
{
private:
    typedef mozilla::dom::fs::FileSystemEntryMetadata FileSystemEntryMetadata;

public:
    MOZ_IMPLICIT FileSystemDirectoryListing() :
        directories_(),
        files_()
    {
    }

    MOZ_IMPLICIT FileSystemDirectoryListing(
            const nsTArray<FileSystemEntryMetadata>& _directories,
            const nsTArray<FileSystemEntryMetadata>& _files) :
        directories_(_directories),
        files_(_files)
    {
    }

    nsTArray<FileSystemEntryMetadata>&
    directories()
    {
        return directories_;
    }
    const nsTArray<FileSystemEntryMetadata>&
    directories() const
    {
        return directories_;
    }

    nsTArray<FileSystemEntryMetadata>&
    files()
    {
        return files_;
    }
    const nsTArray<FileSystemEntryMetadata>&
    files() const
    {
        return files_;
    }

private:
    CopyableTArray<FileSystemEntryMetadata> directories_;
    CopyableTArray<FileSystemEntryMetadata> files_;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemDirectoryListing>
{
    typedef mozilla::dom::fs::FileSystemDirectoryListing paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FileSystemGetEntriesResponse|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemGetEntriesResponse final
{
public:
    enum Type {
        T__None,
        Tnsresult = 1,
        TFileSystemDirectoryListing,
        T__Last = TFileSystemDirectoryListing
    };

private:
    typedef mozilla::dom::fs::FileSystemDirectoryListing FileSystemDirectoryListing;
    typedef nsresult nsresult__tdef;
    typedef FileSystemDirectoryListing FileSystemDirectoryListing__tdef;

    union Value {
        mozilla::AlignedStorage2<nsresult> Vnsresult;
        mozilla::AlignedStorage2<FileSystemDirectoryListing> VFileSystemDirectoryListing;
    };

    nsresult*
    ptr_nsresult()
    {
        return ((mValue).Vnsresult).addr();
    }
    const nsresult*
    constptr_nsresult() const
    {
        return ((mValue).Vnsresult).addr();
    }
    FileSystemDirectoryListing*
    ptr_FileSystemDirectoryListing()
    {
        return ((mValue).VFileSystemDirectoryListing).addr();
    }
    const FileSystemDirectoryListing*
    constptr_FileSystemDirectoryListing() const
    {
        return ((mValue).VFileSystemDirectoryListing).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FileSystemGetEntriesResponse() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FileSystemGetEntriesResponse(const nsresult& aOther);

    MOZ_IMPLICIT FileSystemGetEntriesResponse(nsresult&& aOther);

    MOZ_IMPLICIT FileSystemGetEntriesResponse(const FileSystemDirectoryListing& aOther);

    MOZ_IMPLICIT FileSystemGetEntriesResponse(FileSystemDirectoryListing&& aOther);

    MOZ_IMPLICIT FileSystemGetEntriesResponse(const FileSystemGetEntriesResponse& aOther);

    MOZ_IMPLICIT FileSystemGetEntriesResponse(FileSystemGetEntriesResponse&& aOther);

    ~FileSystemGetEntriesResponse();

    Type
    type() const
    {
        return mType;
    }

    FileSystemGetEntriesResponse&
    operator=(const nsresult& aRhs);

    FileSystemGetEntriesResponse&
    operator=(nsresult&& aRhs);

    FileSystemGetEntriesResponse&
    operator=(const FileSystemDirectoryListing& aRhs);

    FileSystemGetEntriesResponse&
    operator=(FileSystemDirectoryListing&& aRhs);

    FileSystemGetEntriesResponse&
    operator=(const FileSystemGetEntriesResponse& aRhs);

    FileSystemGetEntriesResponse&
    operator=(FileSystemGetEntriesResponse&& aRhs);

    nsresult&
    get_nsresult()
    {
        AssertSanity(Tnsresult);
        return (*(ptr_nsresult()));
    }
    const nsresult&
    get_nsresult() const
    {
        AssertSanity(Tnsresult);
        return (*(constptr_nsresult()));
    }
    operator nsresult&()
    {
        return get_nsresult();
    }
    operator const nsresult&() const
    {
        return get_nsresult();
    }

    FileSystemDirectoryListing&
    get_FileSystemDirectoryListing()
    {
        AssertSanity(TFileSystemDirectoryListing);
        return (*(ptr_FileSystemDirectoryListing()));
    }
    const FileSystemDirectoryListing&
    get_FileSystemDirectoryListing() const
    {
        AssertSanity(TFileSystemDirectoryListing);
        return (*(constptr_FileSystemDirectoryListing()));
    }
    operator FileSystemDirectoryListing&()
    {
        return get_FileSystemDirectoryListing();
    }
    operator const FileSystemDirectoryListing&() const
    {
        return get_FileSystemDirectoryListing();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemGetEntriesResponse>
{
    typedef mozilla::dom::fs::FileSystemGetEntriesResponse paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemGetFileRequest|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemGetFileRequest final
{
private:
    typedef mozilla::dom::fs::EntryId EntryId;

public:
    MOZ_IMPLICIT FileSystemGetFileRequest() :
        entryId_()
    {
    }

    MOZ_IMPLICIT FileSystemGetFileRequest(const EntryId& _entryId) :
        entryId_(_entryId)
    {
    }

    EntryId&
    entryId()
    {
        return entryId_;
    }
    const EntryId&
    entryId() const
    {
        return entryId_;
    }

private:
    EntryId entryId_;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemGetFileRequest>
{
    typedef mozilla::dom::fs::FileSystemGetFileRequest paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemFileProperties|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemFileProperties final
{
private:
    typedef mozilla::dom::fs::TimeStamp TimeStamp;
    typedef mozilla::dom::IPCBlob IPCBlob;
    typedef mozilla::dom::fs::ContentType ContentType;
    typedef mozilla::dom::fs::Name Name;

public:
    MOZ_IMPLICIT FileSystemFileProperties() :
        last_modified_ms_(),
        file_(),
        type_(),
        path_()
    {
    }

    MOZ_IMPLICIT FileSystemFileProperties(
            const TimeStamp& _last_modified_ms,
            const IPCBlob& _file,
            const ContentType& _type,
            const nsTArray<Name>& _path) :
        last_modified_ms_(_last_modified_ms),
        file_(_file),
        type_(_type),
        path_(_path)
    {
    }

    TimeStamp&
    last_modified_ms()
    {
        return last_modified_ms_;
    }
    const TimeStamp&
    last_modified_ms() const
    {
        return last_modified_ms_;
    }

    IPCBlob&
    file()
    {
        return file_;
    }
    const IPCBlob&
    file() const
    {
        return file_;
    }

    ContentType&
    type()
    {
        return type_;
    }
    const ContentType&
    type() const
    {
        return type_;
    }

    nsTArray<Name>&
    path()
    {
        return path_;
    }
    const nsTArray<Name>&
    path() const
    {
        return path_;
    }

private:
    TimeStamp last_modified_ms_;
    IPCBlob file_;
    ContentType type_;
    CopyableTArray<Name> path_;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemFileProperties>
{
    typedef mozilla::dom::fs::FileSystemFileProperties paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FileSystemGetFileResponse|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemGetFileResponse final
{
public:
    enum Type {
        T__None,
        Tnsresult = 1,
        TFileSystemFileProperties,
        T__Last = TFileSystemFileProperties
    };

private:
    typedef mozilla::dom::fs::FileSystemFileProperties FileSystemFileProperties;
    typedef nsresult nsresult__tdef;
    typedef FileSystemFileProperties FileSystemFileProperties__tdef;

    union Value {
        mozilla::AlignedStorage2<nsresult> Vnsresult;
        mozilla::AlignedStorage2<FileSystemFileProperties> VFileSystemFileProperties;
    };

    nsresult*
    ptr_nsresult()
    {
        return ((mValue).Vnsresult).addr();
    }
    const nsresult*
    constptr_nsresult() const
    {
        return ((mValue).Vnsresult).addr();
    }
    FileSystemFileProperties*
    ptr_FileSystemFileProperties()
    {
        return ((mValue).VFileSystemFileProperties).addr();
    }
    const FileSystemFileProperties*
    constptr_FileSystemFileProperties() const
    {
        return ((mValue).VFileSystemFileProperties).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FileSystemGetFileResponse() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FileSystemGetFileResponse(const nsresult& aOther);

    MOZ_IMPLICIT FileSystemGetFileResponse(nsresult&& aOther);

    MOZ_IMPLICIT FileSystemGetFileResponse(const FileSystemFileProperties& aOther);

    MOZ_IMPLICIT FileSystemGetFileResponse(FileSystemFileProperties&& aOther);

    MOZ_IMPLICIT FileSystemGetFileResponse(const FileSystemGetFileResponse& aOther);

    MOZ_IMPLICIT FileSystemGetFileResponse(FileSystemGetFileResponse&& aOther);

    ~FileSystemGetFileResponse();

    Type
    type() const
    {
        return mType;
    }

    FileSystemGetFileResponse&
    operator=(const nsresult& aRhs);

    FileSystemGetFileResponse&
    operator=(nsresult&& aRhs);

    FileSystemGetFileResponse&
    operator=(const FileSystemFileProperties& aRhs);

    FileSystemGetFileResponse&
    operator=(FileSystemFileProperties&& aRhs);

    FileSystemGetFileResponse&
    operator=(const FileSystemGetFileResponse& aRhs);

    FileSystemGetFileResponse&
    operator=(FileSystemGetFileResponse&& aRhs);

    nsresult&
    get_nsresult()
    {
        AssertSanity(Tnsresult);
        return (*(ptr_nsresult()));
    }
    const nsresult&
    get_nsresult() const
    {
        AssertSanity(Tnsresult);
        return (*(constptr_nsresult()));
    }
    operator nsresult&()
    {
        return get_nsresult();
    }
    operator const nsresult&() const
    {
        return get_nsresult();
    }

    FileSystemFileProperties&
    get_FileSystemFileProperties()
    {
        AssertSanity(TFileSystemFileProperties);
        return (*(ptr_FileSystemFileProperties()));
    }
    const FileSystemFileProperties&
    get_FileSystemFileProperties() const
    {
        AssertSanity(TFileSystemFileProperties);
        return (*(constptr_FileSystemFileProperties()));
    }
    operator FileSystemFileProperties&()
    {
        return get_FileSystemFileProperties();
    }
    operator const FileSystemFileProperties&() const
    {
        return get_FileSystemFileProperties();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemGetFileResponse>
{
    typedef mozilla::dom::fs::FileSystemGetFileResponse paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemGetAccessHandleData|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemGetAccessHandleData final
{
private:
    typedef mozilla::ipc::FileDescriptor FileDescriptor;

public:
    MOZ_IMPLICIT FileSystemGetAccessHandleData() :
        file_()
    {
    }

    MOZ_IMPLICIT FileSystemGetAccessHandleData(const FileDescriptor& _file) :
        file_(_file)
    {
    }

    FileDescriptor&
    file()
    {
        return file_;
    }
    const FileDescriptor&
    file() const
    {
        return file_;
    }

private:
    FileDescriptor file_;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemGetAccessHandleData>
{
    typedef mozilla::dom::fs::FileSystemGetAccessHandleData paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FileSystemGetAccessHandleResponse|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemGetAccessHandleResponse final
{
public:
    enum Type {
        T__None,
        TFileSystemGetAccessHandleData = 1,
        Tnsresult,
        T__Last = Tnsresult
    };

private:
    typedef mozilla::dom::fs::FileSystemGetAccessHandleData FileSystemGetAccessHandleData;
    typedef FileSystemGetAccessHandleData FileSystemGetAccessHandleData__tdef;
    typedef nsresult nsresult__tdef;

    union Value {
        mozilla::AlignedStorage2<FileSystemGetAccessHandleData> VFileSystemGetAccessHandleData;
        mozilla::AlignedStorage2<nsresult> Vnsresult;
    };

    FileSystemGetAccessHandleData*
    ptr_FileSystemGetAccessHandleData()
    {
        return ((mValue).VFileSystemGetAccessHandleData).addr();
    }
    const FileSystemGetAccessHandleData*
    constptr_FileSystemGetAccessHandleData() const
    {
        return ((mValue).VFileSystemGetAccessHandleData).addr();
    }
    nsresult*
    ptr_nsresult()
    {
        return ((mValue).Vnsresult).addr();
    }
    const nsresult*
    constptr_nsresult() const
    {
        return ((mValue).Vnsresult).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FileSystemGetAccessHandleResponse() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FileSystemGetAccessHandleResponse(const FileSystemGetAccessHandleData& aOther);

    MOZ_IMPLICIT FileSystemGetAccessHandleResponse(FileSystemGetAccessHandleData&& aOther);

    MOZ_IMPLICIT FileSystemGetAccessHandleResponse(const nsresult& aOther);

    MOZ_IMPLICIT FileSystemGetAccessHandleResponse(nsresult&& aOther);

    MOZ_IMPLICIT FileSystemGetAccessHandleResponse(const FileSystemGetAccessHandleResponse& aOther);

    MOZ_IMPLICIT FileSystemGetAccessHandleResponse(FileSystemGetAccessHandleResponse&& aOther);

    ~FileSystemGetAccessHandleResponse();

    Type
    type() const
    {
        return mType;
    }

    FileSystemGetAccessHandleResponse&
    operator=(const FileSystemGetAccessHandleData& aRhs);

    FileSystemGetAccessHandleResponse&
    operator=(FileSystemGetAccessHandleData&& aRhs);

    FileSystemGetAccessHandleResponse&
    operator=(const nsresult& aRhs);

    FileSystemGetAccessHandleResponse&
    operator=(nsresult&& aRhs);

    FileSystemGetAccessHandleResponse&
    operator=(const FileSystemGetAccessHandleResponse& aRhs);

    FileSystemGetAccessHandleResponse&
    operator=(FileSystemGetAccessHandleResponse&& aRhs);

    FileSystemGetAccessHandleData&
    get_FileSystemGetAccessHandleData()
    {
        AssertSanity(TFileSystemGetAccessHandleData);
        return (*(ptr_FileSystemGetAccessHandleData()));
    }
    const FileSystemGetAccessHandleData&
    get_FileSystemGetAccessHandleData() const
    {
        AssertSanity(TFileSystemGetAccessHandleData);
        return (*(constptr_FileSystemGetAccessHandleData()));
    }
    operator FileSystemGetAccessHandleData&()
    {
        return get_FileSystemGetAccessHandleData();
    }
    operator const FileSystemGetAccessHandleData&() const
    {
        return get_FileSystemGetAccessHandleData();
    }

    nsresult&
    get_nsresult()
    {
        AssertSanity(Tnsresult);
        return (*(ptr_nsresult()));
    }
    const nsresult&
    get_nsresult() const
    {
        AssertSanity(Tnsresult);
        return (*(constptr_nsresult()));
    }
    operator nsresult&()
    {
        return get_nsresult();
    }
    operator const nsresult&() const
    {
        return get_nsresult();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemGetAccessHandleResponse>
{
    typedef mozilla::dom::fs::FileSystemGetAccessHandleResponse paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemEntryPair|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemEntryPair final
{
private:
    typedef mozilla::dom::fs::EntryId EntryId;

public:
    MOZ_IMPLICIT FileSystemEntryPair() :
        parentId_(),
        childId_()
    {
    }

    MOZ_IMPLICIT FileSystemEntryPair(
            const EntryId& _parentId,
            const EntryId& _childId) :
        parentId_(_parentId),
        childId_(_childId)
    {
    }

    EntryId&
    parentId()
    {
        return parentId_;
    }
    const EntryId&
    parentId() const
    {
        return parentId_;
    }

    EntryId&
    childId()
    {
        return childId_;
    }
    const EntryId&
    childId() const
    {
        return childId_;
    }

private:
    EntryId parentId_;
    EntryId childId_;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemEntryPair>
{
    typedef mozilla::dom::fs::FileSystemEntryPair paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemResolveRequest|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemResolveRequest final
{
private:
    typedef mozilla::dom::fs::FileSystemEntryPair FileSystemEntryPair;

public:
    MOZ_IMPLICIT FileSystemResolveRequest() :
        endpoints_()
    {
    }

    MOZ_IMPLICIT FileSystemResolveRequest(const FileSystemEntryPair& _endpoints) :
        endpoints_(_endpoints)
    {
    }

    FileSystemEntryPair&
    endpoints()
    {
        return endpoints_;
    }
    const FileSystemEntryPair&
    endpoints() const
    {
        return endpoints_;
    }

private:
    FileSystemEntryPair endpoints_;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemResolveRequest>
{
    typedef mozilla::dom::fs::FileSystemResolveRequest paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemPath|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemPath final
{
private:
    typedef mozilla::dom::fs::Name Name;

public:
    MOZ_IMPLICIT FileSystemPath() :
        path_()
    {
    }

    MOZ_IMPLICIT FileSystemPath(const nsTArray<Name>& _path) :
        path_(_path)
    {
    }

    nsTArray<Name>&
    path()
    {
        return path_;
    }
    const nsTArray<Name>&
    path() const
    {
        return path_;
    }

private:
    CopyableTArray<Name> path_;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemPath>
{
    typedef mozilla::dom::fs::FileSystemPath paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FileSystemResolveResponse|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemResolveResponse final
{
public:
    enum Type {
        T__None,
        Tnsresult = 1,
        TMaybeFileSystemPath,
        T__Last = TMaybeFileSystemPath
    };

private:
    typedef mozilla::dom::fs::FileSystemPath FileSystemPath;
    typedef nsresult nsresult__tdef;
    typedef mozilla::Maybe<FileSystemPath> MaybeFileSystemPath__tdef;

    union Value {
        mozilla::AlignedStorage2<nsresult> Vnsresult;
        mozilla::AlignedStorage2<mozilla::Maybe<FileSystemPath>> VMaybeFileSystemPath;
    };

    nsresult*
    ptr_nsresult()
    {
        return ((mValue).Vnsresult).addr();
    }
    const nsresult*
    constptr_nsresult() const
    {
        return ((mValue).Vnsresult).addr();
    }
    mozilla::Maybe<FileSystemPath>*
    ptr_MaybeFileSystemPath()
    {
        return ((mValue).VMaybeFileSystemPath).addr();
    }
    const mozilla::Maybe<FileSystemPath>*
    constptr_MaybeFileSystemPath() const
    {
        return ((mValue).VMaybeFileSystemPath).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FileSystemResolveResponse() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FileSystemResolveResponse(const nsresult& aOther);

    MOZ_IMPLICIT FileSystemResolveResponse(nsresult&& aOther);

    MOZ_IMPLICIT FileSystemResolveResponse(const mozilla::Maybe<FileSystemPath>& aOther);

    MOZ_IMPLICIT FileSystemResolveResponse(mozilla::Maybe<FileSystemPath>&& aOther);

    MOZ_IMPLICIT FileSystemResolveResponse(const FileSystemResolveResponse& aOther);

    MOZ_IMPLICIT FileSystemResolveResponse(FileSystemResolveResponse&& aOther);

    ~FileSystemResolveResponse();

    Type
    type() const
    {
        return mType;
    }

    FileSystemResolveResponse&
    operator=(const nsresult& aRhs);

    FileSystemResolveResponse&
    operator=(nsresult&& aRhs);

    FileSystemResolveResponse&
    operator=(const mozilla::Maybe<FileSystemPath>& aRhs);

    FileSystemResolveResponse&
    operator=(mozilla::Maybe<FileSystemPath>&& aRhs);

    FileSystemResolveResponse&
    operator=(const FileSystemResolveResponse& aRhs);

    FileSystemResolveResponse&
    operator=(FileSystemResolveResponse&& aRhs);

    nsresult&
    get_nsresult()
    {
        AssertSanity(Tnsresult);
        return (*(ptr_nsresult()));
    }
    const nsresult&
    get_nsresult() const
    {
        AssertSanity(Tnsresult);
        return (*(constptr_nsresult()));
    }
    operator nsresult&()
    {
        return get_nsresult();
    }
    operator const nsresult&() const
    {
        return get_nsresult();
    }

    mozilla::Maybe<FileSystemPath>&
    get_MaybeFileSystemPath()
    {
        AssertSanity(TMaybeFileSystemPath);
        return (*(ptr_MaybeFileSystemPath()));
    }
    const mozilla::Maybe<FileSystemPath>&
    get_MaybeFileSystemPath() const
    {
        AssertSanity(TMaybeFileSystemPath);
        return (*(constptr_MaybeFileSystemPath()));
    }
    operator mozilla::Maybe<FileSystemPath>&()
    {
        return get_MaybeFileSystemPath();
    }
    operator const mozilla::Maybe<FileSystemPath>&() const
    {
        return get_MaybeFileSystemPath();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemResolveResponse>
{
    typedef mozilla::dom::fs::FileSystemResolveResponse paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemRemoveEntryRequest|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemRemoveEntryRequest final
{
private:
    typedef mozilla::dom::fs::FileSystemChildMetadata FileSystemChildMetadata;

public:
    MOZ_IMPLICIT FileSystemRemoveEntryRequest() :
        handle_(),
        recursive_()
    {
    }

    MOZ_IMPLICIT FileSystemRemoveEntryRequest(
            const FileSystemChildMetadata& _handle,
            const bool& _recursive) :
        handle_(_handle),
        recursive_(_recursive)
    {
    }

    FileSystemChildMetadata&
    handle()
    {
        return handle_;
    }
    const FileSystemChildMetadata&
    handle() const
    {
        return handle_;
    }

    bool&
    recursive()
    {
        return recursive_;
    }
    const bool&
    recursive() const
    {
        return recursive_;
    }

private:
    FileSystemChildMetadata handle_;
    bool recursive_;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemRemoveEntryRequest>
{
    typedef mozilla::dom::fs::FileSystemRemoveEntryRequest paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FileSystemRemoveEntryResponse|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemRemoveEntryResponse final
{
public:
    enum Type {
        T__None,
        Tnsresult = 1,
        Tvoid_t,
        T__Last = Tvoid_t
    };

private:
    typedef mozilla::void_t void_t;
    typedef nsresult nsresult__tdef;
    typedef void_t void_t__tdef;

    union Value {
        mozilla::AlignedStorage2<nsresult> Vnsresult;
        mozilla::AlignedStorage2<void_t> Vvoid_t;
    };

    nsresult*
    ptr_nsresult()
    {
        return ((mValue).Vnsresult).addr();
    }
    const nsresult*
    constptr_nsresult() const
    {
        return ((mValue).Vnsresult).addr();
    }
    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FileSystemRemoveEntryResponse() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FileSystemRemoveEntryResponse(const nsresult& aOther);

    MOZ_IMPLICIT FileSystemRemoveEntryResponse(nsresult&& aOther);

    MOZ_IMPLICIT FileSystemRemoveEntryResponse(const void_t& aOther);

    MOZ_IMPLICIT FileSystemRemoveEntryResponse(void_t&& aOther);

    MOZ_IMPLICIT FileSystemRemoveEntryResponse(const FileSystemRemoveEntryResponse& aOther);

    MOZ_IMPLICIT FileSystemRemoveEntryResponse(FileSystemRemoveEntryResponse&& aOther);

    ~FileSystemRemoveEntryResponse();

    Type
    type() const
    {
        return mType;
    }

    FileSystemRemoveEntryResponse&
    operator=(const nsresult& aRhs);

    FileSystemRemoveEntryResponse&
    operator=(nsresult&& aRhs);

    FileSystemRemoveEntryResponse&
    operator=(const void_t& aRhs);

    FileSystemRemoveEntryResponse&
    operator=(void_t&& aRhs);

    FileSystemRemoveEntryResponse&
    operator=(const FileSystemRemoveEntryResponse& aRhs);

    FileSystemRemoveEntryResponse&
    operator=(FileSystemRemoveEntryResponse&& aRhs);

    nsresult&
    get_nsresult()
    {
        AssertSanity(Tnsresult);
        return (*(ptr_nsresult()));
    }
    const nsresult&
    get_nsresult() const
    {
        AssertSanity(Tnsresult);
        return (*(constptr_nsresult()));
    }
    operator nsresult&()
    {
        return get_nsresult();
    }
    operator const nsresult&() const
    {
        return get_nsresult();
    }

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemRemoveEntryResponse>
{
    typedef mozilla::dom::fs::FileSystemRemoveEntryResponse paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemQuotaRequest|
//
namespace mozilla {
namespace dom {
namespace fs {
class FileSystemQuotaRequest final
{
private:
    typedef mozilla::dom::fs::FileSystemChildMetadata FileSystemChildMetadata;

public:
    MOZ_IMPLICIT FileSystemQuotaRequest() :
        handle_(),
        quotaNeeded_()
    {
    }

    MOZ_IMPLICIT FileSystemQuotaRequest(
            const FileSystemChildMetadata& _handle,
            const uint64_t& _quotaNeeded) :
        handle_(_handle),
        quotaNeeded_(_quotaNeeded)
    {
    }

    FileSystemChildMetadata&
    handle()
    {
        return handle_;
    }
    const FileSystemChildMetadata&
    handle() const
    {
        return handle_;
    }

    uint64_t&
    quotaNeeded()
    {
        return quotaNeeded_;
    }
    const uint64_t&
    quotaNeeded() const
    {
        return quotaNeeded_;
    }

private:
    FileSystemChildMetadata handle_;
    uint64_t quotaNeeded_;
};
} // namespace fs
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::fs::FileSystemQuotaRequest>
{
    typedef mozilla::dom::fs::FileSystemQuotaRequest paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC

namespace mozilla {
namespace dom {
class POriginPrivateFileSystemParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class POriginPrivateFileSystemChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to POriginPrivateFileSystemChild and POriginPrivateFileSystemParent
//
namespace mozilla {
namespace dom {
namespace POriginPrivateFileSystem {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::POriginPrivateFileSystemParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::POriginPrivateFileSystemChild>* aChild);

nsresult
CreateEndpoints(
        mozilla::ipc::Endpoint<mozilla::dom::POriginPrivateFileSystemParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::POriginPrivateFileSystemChild>* aChild);

enum MessageType {
    POriginPrivateFileSystemStart = POriginPrivateFileSystemMsgStart << 16,
    Msg_GetDirectoryHandle__ID,
    Reply_GetDirectoryHandle__ID,
    Msg_GetFileHandle__ID,
    Reply_GetFileHandle__ID,
    Msg_GetFile__ID,
    Reply_GetFile__ID,
    Msg_GetAccessHandle__ID,
    Reply_GetAccessHandle__ID,
    Msg_GetWritable__ID,
    Reply_GetWritable__ID,
    Msg_Resolve__ID,
    Reply_Resolve__ID,
    Msg_GetEntries__ID,
    Reply_GetEntries__ID,
    Msg_RemoveEntry__ID,
    Reply_RemoveEntry__ID,
    Msg_CloseFile__ID,
    Msg_NeedQuota__ID,
    Reply_NeedQuota__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    POriginPrivateFileSystemEnd
};

mozilla::UniquePtr<IPC::Message>
Msg_GetDirectoryHandle(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_GetDirectoryHandle(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_GetFileHandle(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_GetFileHandle(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_GetFile(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_GetFile(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_GetAccessHandle(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_GetAccessHandle(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_GetWritable(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_GetWritable(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_Resolve(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_Resolve(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_GetEntries(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_GetEntries(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RemoveEntry(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_RemoveEntry(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_CloseFile(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_NeedQuota(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_NeedQuota(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg___delete__(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply___delete__(int32_t routingId);



} // namespace POriginPrivateFileSystem
} // namespace dom
} // namespace mozilla

#endif // ifndef POriginPrivateFileSystem_h
